dojo.declare("classes.ui.FW7UI", classes.ui.UISystem, {

    // reference to common popup with view
    popupView: null,

    
    lastUpdatedTime: 0,

    notification: null,

    constructor: function(){
        this.notification = new classes.mobile.Notification();
        this.notification.init();
    },

    render: function(){
        var game = this.game;
    },

    update: function() {
        eventTime = new Date().getTime();
        //events #1: 0, 200, 500, assume that next should at 600 => 0, 200, 500, 600 
        // events#2: 0, 200, 780, 790, 800, in this case we need to drop 2 next frames, however we don't know what is excpected time for frame

        if (this.lastUpdatedTime) {
            var min = this.lastUpdatedTime + 50;
            if (eventTime < min) {
                return;
            }
        }
        
        this.lastUpdatedTime = eventTime;

        var self = this;
        //setTimeout(function() {
            dojo.publish("game/update", [self.game]);
        //}, 10);
        this.updateCalendar();
    },



    saveExport: function(encodedData) {
        // if (!cordova.plugins.clipboard) {
        //     fw7App.alert("Clipborad plugin isn't installed", 'Export failed');
        //     return;
        // }

        // // var plugins = cordova.require("cordova/plugin_list").metadata;
        // // if (typeof plugins['cordova-plugin-whitelist'] === "undefined")
        // // {
        // //     // This plugin is missing
        // // }

        // cordova.plugins.clipboard.copy(encodedData, function(){
        //     fw7App.alert("The game was exported to clipboard", 'Export completed');
        // }, function(msg) {
        //     fw7App.alert(encodedData, 'Export completed');
        //     //fw7App.alert("The game wasn't exported due to error:"+msg, 'Export failed');
        // });
        
    },

    updateOptions: function() {
        var game = this.game;
        $("body").children().each(function(index, item){
            dojo.removeClass(item, ["scheme-default", "scheme-dark", "scheme-black"]);
            dojo.addClass(item, "scheme-" + (game.colorScheme || "default"));
        });

         
    },

    notifyLogEvent: function(logmsg) {
        dojo.publish("game/logEvent", [this.game]);
        // fw7App.addNotification({
        //     //title: 'Event',
        //     message: logmsg.text,
        //     hold: 3000,
        //     closeIcon: false
        // });
    },

    confirm: function(title, msg, callback) {
        fw7App.confirm(msg, title, function() {
            invokeCallback(callback, [true]);
        }, function() {
            invokeCallback(callback, [false]);
        });
    },

    openPopupPage: function(pageName) {
        this.popupView.router.load({pageName: pageName}); // load first to avoid possible blinking
        fw7App.popup(".common-popup");
    },

    pulse: function(node){

    },

    observeCallback: function(observeHandler){
        dojo.publish("game/observeEvent", [dojo.hitch(this.game.calendar, observeHandler)]);
    },

    observeClear: function(){
        dojo.publish("game/observeEvent", null);
    },

    updateCalendar: function(){
        var calendar = this.game.calendar;
        var seasonTitle = calendar.getCurSeasonTitle();
        var hasCalendarTech = this.game.science.get("calendar").researched;

        var calendarText = "N/A";
        if (calendar){
            if (hasCalendarTech) {
                var mod = "";
                if (calendar.weather){
                    mod = " (" + $I("calendar.weather." + calendar.weather) + ")";
                }

                //calendarText = "Year " + calendar.year/*this.game.getDisplayValueExt(calendar.year, false, false, 0)*/ + " - " +
                //    calendar.seasons[calendar.season].title + mod + ", day " + calendar.integerDay();

                calendarText = $I("calendar.year.full", [calendar.year, (calendar.seasons[calendar.season].title + mod), calendar.integerDay()])

                var cycle = calendar.cycles[calendar.cycle];
                if (cycle && this.game.science.get("astronomy").researched){
                    calendarText = cycle.uglyph + calendarText;
                }
            } else {
                calendarText = calendar.getCurSeasonTitle();
            }
        }
        dojo.publish("calendar/update", [calendarText]);

    }
});
