WLogViewHelper = {
    getMessages: function(messages) {
        var items = [];
        var i = 0;
        

        for (; i < messages.length; i++) {
            var msg = messages[i];
            var style = {};
            // if (i > 24) {
            //     style["opacity"] = 1 - (i-24) * 0.066;
            // }
            var classes = "msg";
            if (msg.type){
                classes += " type_"+msg.type;
            }
            if (msg.noBullet) {
                classes += " noBullet";
            }

            if (msg.hasCalendarTech) {
                var timestamp = msg.seasonTitleShorten+"/"+msg.year+": ";
                items.push(
                    $r("p", {style:style, className: classes}, [
                        $r('span', {className: 'log-timestamp'}, timestamp),
                        msg.text
                    ])
                );
            } else {
                items.push(
                    $r("p", {style:style, className: classes}, msg.text)
                );
            }
        }

        if (!items.length) {
            items.push($r("p", {}, $I("console.intro")));
        }
        return items;
    }

};

WLogConsole = React.createClass({
    displayName: "WLogConsole",

    getInitialState: function() {
        return {
            messages: []
        };
    },

    componentDidMount: function() {
        var self = this;
        dojo.subscribe("game/logEvent", function(game) {
            setTimeout(dojo.hitch(self, dojo.partial(self.onChange, game)), 0);
        });
    },

    onChange: function(game){
        this.setState({
            messages: game.console.messages
        });
    },

    render: function() {
        var items = WLogViewHelper.getMessages(this.state.messages);

        /* <div class="popup popup-log">
            <div class="toolbar">
              <div class="toolbar-inner">
                <div class="left"></div>
                <div class="right"><a href="#" class="close-picker">Done</a></div>
              </div>
            </div>
            <!--div class="popover-inner"-->
              <div class="content-block">
                <p>About</p>
                <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque ac diam ac quam euismod porta vel a nunc. Quisque sodales scelerisque est, at porta justo cursus ac.</p>
              </div>
            <!--/div-->
          </div>*/

        return $r("div", {
                className: "popup log-popup"
            }, [
                $r("div", {className : "toolbar"}, [
                    $r("div", {className : "toolbar-inner"}, [
                        $r("div", {className : "left"}),
                        $r("div", {className : "right"}, [
                            $r("a", {href:"#", className:"close-popup"}, $I("menu.close"))
                        ])
                    ])
                ] ),
                /*$r("div", {className : "popup-inner"}, [*/
                    $r("div", {className : "content-block log-popup-content"}, items )
                /*])*/
            ]);
    }
});

WObserveButton = React.createClass({
    displayName: "WObserveButton",

    observeHandlerToApply: null,
    subscribeHander: null,

    getInitialState: function() {
        return {
            observeHandler: null
        };
    },

    componentDidMount: function() {
        var self = this;
        this.subscribeHander = dojo.subscribe("game/observeEvent", function(observeHandler) {
            self.observeHandlerToApply = observeHandler;
            setTimeout(dojo.hitch(self, self.onChange), 0);
        });
    },

    componentWillUnmount: function() {
        if (this.subscribeHander) {
            dojo.unsubscribe(this.subscribeHander);
        } 
    },

    onChange: function(){
        this.setState({
            observeHandler: this.observeHandlerToApply
        });
    },

    render: function() {
        return $r("a", {href : "#", 
                    className: this.props.className,
                    onClick: this.observeHandler, // used for perf reason
                    style: {display: this.state.observeHandler ? "" : "none"}
                }, $I("navbar.observe.short"));
    },

    observeHandler: function() {
        this.state.observeHandler();
    }
});


WLogPreviewPanel = React.createClass({
    displayName: "WLogPreviewPanel",

    render: function() {
        return $r("div", {
            className: "kg-log-notification-panel"
        }, [
            $r("div", {className : "kg-log-notification-panel-inner"}, [
                $r(WObserveButton, {
                    className: "kg-log-notification-panel-observe-btn"
                }), 
                $r(WLogPreview, {
                    className: "kg-log-notification-panel-msg-area",
                    onClick: this.openLogPopup,
                    limit: 3
                })
                
            ])
        ]);
    },

    openLogPopup: function() {
        fw7App.popup('.log-popup');
    }
});


WLogPreview = React.createClass({
    displayName: "WLogPreview",

    //mixins: [React.PureComponent],
    subscribeHander: null, 
    getDefaultProps: function() {
        return {
            className: null,
            limit: 9999,
            onClick: null
        };
    },

    getInitialState: function() {
        return {
            messages: []
        };
    },

    componentDidMount: function() {
        var self = this;
        this.subscribeHander = dojo.subscribe("game/logEvent", function(game) {
            setTimeout(dojo.hitch(self, dojo.partial(self.onChange, game)), 0);
        });
        dojo.publish("game/logEvent", [game]);  //bootstrap all log entries that might be generated prior to control initialization (read: redshift messages)
    },

    componentWillUnmount: function() {
        if (this.subscribeHander) {
            dojo.unsubscribe(this.subscribeHander);
        } 
    },

    onChange: function(game){
        this.setState({
            messages: game.console.messages.slice(-this.props.limit)
        });
    },
    
    render: function() {
        var items = WLogViewHelper.getMessages(this.state.messages);

        return $r("div", {
            className: this.props.className,
            onClick: this.onClick
        }, items );
    },

    onClick: function() {
        if (this.props.onClick) {
            this.props.onClick();
        }
    }
    
});