//TODO: make a generic popup widget

WSimpleOpt = React.createClass({
    displayName: "WSimpleOpt",
    getInitialProps: function(){
        return {
            title: null,
            desc: null,
            opt: null
        };
    },
    render: function(){
        var content = [$r("ul",{}, [
            $r("li",{}, [
                $r(WSmartSelect, {
                    title: this.props.title,
                    items: [
                        {value: "true", label: $I("opts.yes")},
                        {value: "false", label: $I("opts.no")}
                    ],
                    selectedValue: game.opts[this.props.opt],
                    onChange: this.toggle
                })
            ])

        ])];
        if (this.props.desc){
            content.push(
                $r("div", {className : "list-block-label"}, this.props.desc)
            );
        }
        return $r("div", {}, [content]);
    },

    toggle: function(evt){
        game.opts[this.props.opt] = "true" == evt.target.value;

        game.save();
        dojo.publish("game/options", [game]);
    }
});

WOptionsPopup = React.createClass({
    displayName: "WOptionsPopup",
    //mixins: [React.PureComponent],
    optionsView: null,
    
    getInitialState: function() {
        return {
            colorScheme: "",
            useWorkers: false
        };
    },

    componentDidMount: function() {
        dojo.subscribe("game/options", dojo.hitch(this, this.onChange));
        fw7App.initSmartSelects(React.findDOMNode(this));
        this.onChange(game);
    },

    onChange: function(game){

        this.setState({
            colorScheme: game.colorScheme,
            useWorkers: game.useWorkers
        });
    },

    render: function() {

        var localeOpts = [],
            locales = i18nLang.getAvailableLocales();

        for (var i in locales){
            localeOpts.push({
                value: locales[i],
                label: i18nLang.getAvailableLocaleLabels()[locales[i]]
            });
        }

        return $r("div", {
            className: "full-screen-position"
        }, [

            $r("div", {className : "navbar"}, [
                $r("div", {className : "navbar-inner"}, [
                    $r("div", {className : "left"}),
                    $r("div", {className : "right"}, [
                        $r("a", {href:"#", className:"close-popup"}, $I("menu.close"))
                    ])
                ])
            ] ),

            $r("div", {className : "page", dataPage:"home"}, [
                $r("div", {className : "page-content options-popup-content"}, [
                    $r("div", {className : "content-block-title"}, $I("opts.group.interface")),
                    $r("div", {className : "list-block"}, [
                        $r("ul",{}, [
                            $r("li",{}, [
                                $r(WSmartSelect, {
                                    title: $I("opts.theme"),
                                    items: [
                                        {value: "default", label: $I("opts.theme.classic")},
                                        {value: "dark", label: $I("opts.theme.inverted")},
                                        {value: "black", label: $I("opts.theme.black")}
                                    ],
                                    selectedValue: this.state.colorScheme,
                                    onChange: this._handleSchemaChange
                                })

                            ])

                        ]),
                        $r("ul",{}, [
                            $r("li",{}, [
                                $r(WSmartSelect, {
                                    title: $I("menu.language"),
                                    items: localeOpts,
                                    selectedValue: i18nLang.getLanguage(),
                                    onChange: this._handleLocaleChange
                                })

                            ])

                        ]),
                        $r(WSimpleOpt, {title: $I("opts.percentage"), opt: "usePercentageResourceValues", desc: $I("opts.percentage.desc")}),
                        $r(WSimpleOpt, {title: $I("opts.highlight"), opt: "highlightUnavailable", desc:$I("opts.highlight.desc")}),
                        $r(WSimpleOpt, {title: $I("opts.precision"), opt: "forceHighPrecision", desc: $I("opts.precision.desc")}),
                        $r(WSimpleOpt, {title: $I("opts.hideSell"), opt: "hideSell", desc: $I("opts.hideSell.desc")}),
                        $r(WSimpleOpt, {title: $I("opts.tabLayout"), opt: "useLegacyTwoInRowLayout", desc:$I("opts.tabLayout.desc")})
                    ])
                ])
            ])
        ]);
    },

    _handleLocaleChange: function(evt){
        i18nLang.updateLanguage(evt.target.value);
        window.location.reload();
    },

    _handleSchemaChange: function(evt) {
        game.colorScheme = evt.target.value;

        game.updateOptionsUI();
    },

    _handleUseWorkersChange: function(evt) {
        game.useWorkers = "true" == evt.target.value;

        game.save();
    }
    
});


