WCollapsibleRow = React.createClass({
    getInitialState: function() {
        return {
            collapsed: true
        };
    },

    render: function() {
        return $r("ul", {},
            $r("li", {className: "accordion-item"},
                [
                    $r(WStatelessCollapsibleSection, {
                        collapsed: this.state.collapsed,
                        title: $r("div", {className: "item-title res-row"}, this.props.title),
                        ontoggle: this.toggle
                    }, [
                        $r("div", {className: "item-inner res-details"},
                            $r("div", {className: "content-block"},
                                this.props.content
                            )
                        )
                    ])
                ]
            )
        );
    },

    toggle: function(){
        this.setState({
            collapsed: !this.state.collapsed
        });
    }
});

WResourceTableRow = React.createClass({
    displayName: "WResourceTableRow",
    mixins: [React.PureComponent], // It will mixin shouldComponentUpdate method with simple plain object structure comparasion. It might not work correct with complex data structures:
    // please visit: https://facebook.github.io/react/docs/optimizing-performance.html
    //mixins: [ReactComponentWithPureRenderMixin],

    getInitialProps: function() {
        return {
            name: "RES NAME",
            title: null,
            value: "VAL",
            maxValue: "VAL MAX",
            perTick: null,
            resValueClass: null
        };
    },

    getInitialState: function() {
        return {
            collapsed: true
        };
    },

    render: function() {
        if (!this.state.collapsed) {
            var resTooltip = "<span class='tooltip-res-value-fallback'>" + $I("navbar.res.amount") + ": " +this.props.value + " " + this.props.maxValue + "<br><br></span>";
            resTooltip += game.getDetailedResMap(this.props.res);
        }

        var resStyle = {};
        var resMeta = game.resPool.get(this.props.name);   //UGLY

        if (resMeta.type == "uncommon"){
            resStyle = {color: "Coral"};
        }
        if (resMeta.type == "rare"){
            resStyle = {
                color: "orange",
                textShadow: "1px 0px 10px Coral"
            };
        }
        if (resMeta.color){
            resStyle = {
                color: resMeta.color
            };
        }
        if (resMeta.style){
            for (var styleKey in resMeta.style){
                resStyle[styleKey] = resMeta.style[styleKey];
            }
        }

        return $r("ul", {},
            $r("li", {className: "accordion-item"},
                [
                    $r(WStatelessCollapsibleSection, {
                        collapsed: this.state.collapsed,
                        title: $r("div", {className: "item-title res-row res-" + this.props.name},
                            [
                                $r("div", {className: "res-cell res-title", style: resStyle}, this.props.title + ":"),
                                $r("div", {className: "res-cell" + this.props.resValueClass}, this.props.value),
                                $r("div", {className: "res-cell res-max"}, this.props.maxValue),
                                $r("div", {className: "res-cell res-per-tick"}, this.props.perTick)
                            ]
                        ),
                        ontoggle: this.toggle
                    }, [
                        $r("div", {className: "item-inner"},
                            $r("div", {className: "content-block res-details"},
                                $r("p", {dangerouslySetInnerHTML: { __html: resTooltip}})
                            )
                        )
                    ])
                ]
            )
        );
    },

    toggle: function(){
        this.setState({
            collapsed: !this.state.collapsed
        });
    }

    /*, shouldComponentUpdate: function(nextProps, nextState, nextContext) {
        this.state.resources
        var res = this.props;
    }*/
});

WCraftTableRow = React.createClass({
    mixins: [React.PureComponent],
    displayName: "WCraftTableRow",

    getInitialProps: function() {
        return {
            name: "RES NAME",
            title: "RES TITLE",
            value: "VAL"
        };
    },

    getInitialState: function() {
        return {
            collapsed: true
        };
    },

    render: function() {
        var res = this.props;
        var resStyle = {};

        var resMeta = game.resPool.get(this.props.name);   //UGLY
        if (resMeta.color){
            resStyle = {
                color: resMeta.color
            };
        }
        if (resMeta.style){
            for (var styleKey in resMeta.style){
                resStyle[styleKey] = resMeta.style[styleKey];
            }
        }

        return $r("ul", {},
            $r("li", {className: "accordion-item"},
                [
                    $r(WStatelessCollapsibleSection, {
                        title: $r("div", {className: "item-title res-row"},
                            [
                                $r("div", {className: "res-cell", style: resStyle}, res.title || res.name + ":"),
                                $r("div", {className: "res-cell"}, game.getDisplayValueExt(res.value))
                            ]
                        ),
                        collapsed: this.state.collapsed,
                        ontoggle: this.toggle
                    }, [
                        $r("div", {className: "item-inner"},
                            $r("div", {className: ""},
                               [
                                   this.createCraftButtons()
                               ]
                            )
                        )
                    ])
                ]
            )
        );
    },

    createCraftButtons: function(){
        if (this.state.collapsed){
            return;
        }

        var ratio = game.getResCraftRatio(this.props);

        return $r("div", { className: "craft-tooltip-buttons"}, [
            $r("p", { className: "buttons-row"},
                [
                    this.createCraftButton(1, ratio, 0.01),
                    this.createCraftButton(25, ratio, 0.05)
                ]
            ),
            $r("p", { className: "buttons-row"},
                [
                    this.createCraftButton(100, ratio, 0.1),
                    $r("a", { className: "button button-raised", href: "#", onClick: this.craftAll}, $I("resources.craftTable.all"))
                ]
            )
        ]);
    },

    createCraftButton: function(num, craftRatio, ratio){
        var allCount = game.workshop.getCraftAllCount(this.props.name);
        var craftRowAmt = num;
        if (num < allCount * ratio ){
            craftRowAmt = Math.floor(allCount * ratio);
        } else {
            craftRowAmt = num;
        }

        return $r("a", { 
            className: "button button-raised",
             href: "#", 
             'data-amount': num,
             'data-ratio': ratio,
             onClick: this.craft
         }, "+" + game.getDisplayValueExt(craftRowAmt * (1+craftRatio), null, null, 0));
    },

    craft: function(e){
        var amt = e.target.dataset.amount;
        var ratio= e.target.dataset.ratio;
        /*var res = this.props;
        game.workshop.craft(res.name, amt);*/

        var res = this.props;

        var allCount = game.workshop.getCraftAllCount(res.name);
        if (amt < allCount * ratio){
            amt = allCount * ratio;
        }
        game.craft(res.name, amt);
    },

    craftAll: function(){
        game.craftAll(this.props.name);
    },

    toggle: function(){
        this.setState({
            collapsed: !this.state.collapsed
        });
    }
});

WResourceTable = React.createClass({
    displayName: "WResourceTable",

    getDefaultProps: function() {
        return {
            resources: []
        };
    },


    render: function() {
        var resources = this.getResources();
        return $r("div", {className: "list-block accordion-list res-table res-resources"},
            resources
        );
    },

    getResources: function(){
        var resources = [];
        for (var i in this.props.resources){
            var res = this.props.resources[i];

            if (!res.visible){
                continue;
            }

            if (game.resPool.isNormalCraftableResource(res) && game.workshop.getCraft(res.name).unlocked){
                continue;
            }

            var isVisible = (res.unlocked || (res.name == "kittens" && res.maxValue)) &&
                res.name != "temporalFlux";

            if (!isVisible){
                continue;
            }

            /* -------------------------------
             per tick
             --------------------------------- */

            var perTick = game.calendar.day < 0 ? 0 : game.getResourcePerTick(res.name, true);
            perTick = game.opts.usePerSecondValues ? perTick * game.getRateUI() : perTick;

            var postfix = game.opts.usePerSecondValues ? "/" + $I("res.per.sec") : "";
            if (game.opts.usePercentageResourceValues && res.maxValue){
                perTick = (perTick / res.maxValue * 100);
                postfix = "%" + postfix;
            }

            var perTickValue = perTick ? ( game.getDisplayValueExt(perTick, true, false) + postfix) : "";

            var resValueClass = " res-amount";
            if (res.value > res.maxValue * 0.95 && res.maxValue > 0){
                resValueClass = " res-amount res-limit-notice";
            } else if (res.value > res.maxValue * 0.75 && res.maxValue > 0){
                resValueClass = " res-amount res-limit-warn";
            }

            resources.push($r(WResourceTableRow, {
                title: res.title || res.name,
                name: res.name,
                value: game.getDisplayValueExt(res.value),
                maxValue: res.maxValue ? "/" + game.getDisplayValueExt(res.maxValue) : "",
                perTick: perTickValue,
                resValueClass: resValueClass,
                res: res,
                key: res.name
            }));
        }
        return [
            resources
        ];
    }
});

WCraftTable = React.createClass({
    displayName: "WCraftTable",

    workshop: null,

    getDefaultProps: function(){
        return {
            resources: [],
            collapsed: true
        };
    },

    componentDidMount: function() {
        this.workshop = game.bld.get("workshop");
    },

    render: function() {
        var resources = this.getResources();
        return $r("div", {className: "list-block accordion-list res-table res-craft"},
            resources
        );
    },

    getResources: function(){
        var resources = [];
        for (var i in this.props.resources){
            var res = this.props.resources[i];
            if (!res.craftable){
                continue;
            }

            var recipe = game.workshop.getCraft(res.name);
            if (!recipe.unlocked || !res.value || !this.workshop|| !this.workshop.on){
                continue;
            }

            resources.push($r(WCraftTableRow, {
                name: res.name,
                title: res.title,
                value: res.value,
                key: res.name
            }));
        }
        return [
            resources
        ];
    }
});

/**
 * Quick access button
 */
WResourceButton = React.createClass({
    displayName: "WResourceButton",
    mixins: [AbstractButtonClass],

    render: function(){
       return $r("div", {className: "list-block accordion-list kg-quicklaunch", onClick: this._onClick},
           $r("ul", {},
               $r("li", {className: "accordion-item"}, this.props.name)
           )
       );
    },

    _onClick: function(){
        this.animate();
        this.props.handler();
    }
});

WResourceSlider = React.createClass({
    displayName: "WResourceSlider",
    subscribeHander: null,
    subscribeHander2: null,
    componentDidMount: function() {
        var self = this;
        this.subscribeHander = dojo.subscribe("game/update", function(game) {
            setTimeout(dojo.hitch(self, dojo.partial(self.onChange, game)), 0);
        });
        this.subscribeHander2 = dojo.subscribe("ui/toggleResources", dojo.hitch(this, this.toggle));
    },

    componentWillUnmount: function() {
        if (this.subscribeHander) {
            dojo.unsubscribe(this.subscribeHander);
        } 
        if (this.subscribeHander2) {
            dojo.unsubscribe(this.subscribeHander2);
        } 
    },

    onChange: function(game){
        this.setState({
            resources: game.resPool.resources,
            collapsed: this.state.collapsed
        });
    },


    getInitialState: function() {
        return {
            resources: [],
            collapsed: true
        };
    },

    shouldComponentUpdate: function(nextProps, nextState) {
        var dom = React.findDOMNode(this);
        if (this.state.collapsed && nextState.collapsed && dom.offsetParent === null) {
            return false;
        }
        return true;
    },

    render: function(){
        var collapsedClass = this.state.collapsed ? " collapsed" : "";

        var catpower = game.resPool.get("manpower");

        var energyBar = null;
        if (game.science.get("electricity").researched ){
            var resPool = game.resPool,
                energy = resPool.energyProd - resPool.energyCons,
                delta = resPool.getEnergyDelta();

            energyBar = $r("div", {className: "list-block accordion-list kg-quicklaunch"},
                $r(WCollapsibleRow, {title: $I("navbar.energy", [Math.floor(energy)]), content: [
                    $r("div", {}, $I("navbar.energy.prod", [Math.floor(resPool.energyProd)])),
                    $r("div", {}, $I("navbar.energy.cons", [Math.floor(resPool.energyCons)])),
                    energy < 0 ? $r("div", {}, $I("navbar.energy.penalty",[Math.floor( (1-delta) * 100)])) : null
                ]}, [])
            );
        }

        return $r("div", {
            className: "page resources-page" + collapsedClass,
            "data-page": "index-left",
            onClick: this.hidePanels
        }, [
            $r("div", {className: "page-content"},
                $r("div", {className: "res-quicklaunch-bar" },[
                    catpower.maxValue > 1000 ? $r(WResourceButton, {
                        name: $I("navbar.btn.hunters"),
                        handler: this.sendAllHunter
                    }) : null,

                    game.religion.faith > 1000 ? $r(WResourceButton, {
                        name: $I("navbar.btn.praise"),
                        handler: this.praiseToSun
                    }) : null
                ]),

                energyBar,


                $r(WResourceTable, {
                    key: "resource-table",
                    collapsed: this.state.collapsed,
                    resources: this.state.resources
                }),
                $r(WCraftTable, {
                    key: "craft-table",
                    collapsed: this.state.collapsed,
                    resources: this.state.resources
                })
            )
        ]);
    },

    toggle: function(collapsed){
        this.setState({
            collapsed: collapsed,
            resources: this.state.resources
        });
    },

    hidePanels: function(){
        fw7App.closePanel();
    },

    sendAllHunter: function(e) {
        game.village.huntAll();
    },

    praiseToSun: function(e) {
        game.religion.praise();
    }


});
