WStagingBldBtn = React.createClass({
    displayName: "WStagingBldBtn",
    
    render: function(){
        ButtonUtils.fetchModel(this);
        

        return $r(WBuildingBtn, {
            controller: this.controller,
            model: this.model,
            mainButtonTitle: $I("btn.build"),
            subButtons: this.model.stageLinks
        });
    }
});


WBonfireTab = React.createClass({
    displayName: "WBonfireTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game,
            filter: this.state.filter
        });
    },

    getInitialState: function() {
        return {
            game: game,
            filter: 'all'
        };
    },

    render: function() {
        var buttons = [];

        var twoRows = false;
        //760px or more
        if (!this.props.media.maxWidth760 && !this.props.media.maxWidth320) {
            twoRows = true;
        }

        var buttons = [];

        //hide buttons once workshop is researched and wood craft snippet is accessible
        if (!game.bld.get("workshop").val){
            var btn = $r(WSimpleButton, {
                key: "gatherCatnip",
                name: $I("buildings.gatherCatnip.label"),
                controller: new classes.game.ui.GatherCatnipButtonController(game),
                description: $I("buildings.gatherCatnip.desc"),
                twoRow: twoRows,
                animateSelector: ".res-catnip"
            });
            buttons.push(btn);

            var isEnriched = game.workshop.get("advancedRefinement").researched;

            btn = $r(WSimpleButton, {
                key: "refineCatnip",
                name: $I("buildings.refineCatnip.label"),
                controller: new classes.game.ui.RefineCatnipButtonController(game),
                handler: function (btn) {
                    game.bld.refineCatnip();
                },
                description: $I("buildings.refineCatnip.desc"),
                prices: [{name: "catnip", val: (isEnriched ? 50 : 100)}],
                twoRow: twoRows,
                animateSelector: ".res-wood",
                showTooltip: game.resPool.get("wood").value <= 10
            });
            buttons.push(btn);
        }


        var bldButtons = [];
        var visibleTotal = 0;
        for (var i in game.bld.buildingsData){

            var bldMetaRaw = game.bld.buildingsData[i];
            var bld = new classes.BuildingMeta(bldMetaRaw).getMeta();

            var btnClass, btnProps;
            if (typeof(bld.stages) == "object"){
                btnProps = {
                    key:            bld.name,
                    name:           bld.label,
                    description:    bld.description,
                    building:       bld.name,
                    twoRow:         twoRows,
                    controller: new classes.ui.btn.StagingBldBtnController(game)
                };
                btnClass = WStagingBldBtn;
            } else {
                btnProps = {
                    key:            bld.name,
                    name:           bld.label,
                    description:    bld.description,
                    building:       bld.name,
                    twoRow:         twoRows,
                    controller: new classes.ui.btn.BuildingBtnModernController(game)
                };
                btnClass = WBuildingBtn;
            }

            var model = btnProps.controller.fetchModel(btnProps);

            if (!model.visible){
                continue;   //skip invisible buttons to not make gaps in the two rows renderer
            }
            visibleTotal++;

            if (!model.enabled && this.state.filter == 'enabled'){
                continue;
            }

            if (model.resourceIsLimited && this.state.filter == 'available'){
                continue;
            }

            bldButtons.push(
                $r(btnClass, btnProps)
            );
        }

        var navButtons = [];
        if (visibleTotal > 10){
            // Come on. Never do the hitch in the render method!!!! BTW Reach does it for you
            navButtons.push(
                $r("div", {className: "buttons-row tabs-row", style: {"padding-top": "5px"}, key: "filters"},[
                    $r("a", { 
                        className: "button kg-button-build button-raised"+ (this.state.filter == "enabled"? " wgt-disabled" : ''), 
                        href: "#", 
                        'data-filter': 'enabled',
                        onClick: this.setFilter
                    }, $I("ui.filter.enabled")),
                    $r("a", { 
                        className: "button kg-button-build button-raised"+ (this.state.filter == "available"? " wgt-disabled" : ''), 
                        href: "#", 
                        'data-filter': 'available',
                        onClick:this.setFilter
                    }, $I("ui.filter.available")),
                    $r("a", { 
                        className: "button kg-button-build button-raised"+ (this.state.filter == "all"? " wgt-disabled" : ''), 
                        href: "#", 
                        'data-filter': 'all',
                        onClick: this.setFilter
                    }, $I("ui.filter.all"))
                ]
            ));
        }

        for (var i in bldButtons){
            buttons.push(bldButtons[i]);
        }

        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", { className: "kg-button-container"}, navButtons),
            $r("ul", { className: "kg-button-container"},
                twoRows? TwoInRowHelper.layout(buttons, false) : buttons
            )
        );
    },

    setFilter: function(e){
        var filter = e.target.dataset.filter;
        this.setState({
            game: this.state.game,
            filter: filter
        });
    }
});