WSacrificeBtn = React.createClass({
    displayName: "WSacrificeBtn",
    render: function(){
        ButtonUtils.fetchModel(this);
        
        return $r(WBuildingBtn, {
            controller: this.controller,
            model: this.model,
            mainButtonTitle: "Sacrifice",
            subButtons: [{
                enabled: this.model.allLink.visible,
                title: this.model.allLink.title, 
                handler: this.model.allLink.handler
            }, {
                enabled: this.model.x10Link.visible,
                title: this.model.x10Link.title, 
                handler: this.model.x10Link.handler
            }]
        });
    }
});

WReligionTab = React.createClass({
    displayName: "WReligionTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },
    
    render: function() {
        var twoRows = false;
        //1020px or more
        if (!this.props.media.maxWidth1020 && !this.props.media.maxWidth760 && !this.props.media.maxWidth320) {
            twoRows = true;
        }
        
        var zuButtons = [];
        var zUpgrades = game.religion.zigguratUpgrades;
        var zigguratCount = game.bld.get("ziggurat").on;
        if (zigguratCount > 0){
            var sacrificeBtn = $r(WSacrificeBtn, {
                name: $I("religion.sacrificeBtn.label"),
                description: $I("religion.sacrificeBtn.desc"),
                prices: [{ name: "unicorns", val: 2500}],
                controller: new classes.ui.religion.SacrificeBtnController(game)
            });

            zuButtons.push(sacrificeBtn);

            var sacrificeAlicornsBtn = $r(WSacrificeBtn, {
                name: $I("religion.sacrificeAlicornsBtn.label"),
                description: $I("religion.sacrificeAlicornsBtn.desc"),
                prices: [{ name: "alicorn", val: 25}],
                controller: new classes.ui.religion.SacrificeAlicornsBtnController(game)
            });
            zuButtons.push(sacrificeAlicornsBtn);


            var refineBtn = $r(WButtonModern, {
                name: $I("religion.refineTearsBtn.label"),
                description: $I("religion.refineTearsBtn.desc"),
                prices: [{ name: "tears", val: 10000}],
                controller: new classes.ui.religion.RefineTearsBtnController(game),
                mainButtonTitle: $I("btn.refine")
            });
            zuButtons.push(refineBtn);

            var refineTCBtn = $r(WButtonModern, {
                name: $I("religion.refineTCsBtn.label"),
                description: $I("religion.refineTCsBtn.desc"),
                prices: [{ name: "timeCrystal", val: 25}],
                controller: new classes.ui.religion.RefineTCBtnController(game),
                mainButtonTitle: $I("btn.refine")
            });
            zuButtons.push(refineTCBtn);

            //TODO: all the dark miracles there
            var zigguratController = new com.nuclearunicorn.game.ui.ZigguratBtnController(game);
            var zigguratUpgrades = game.religion.zigguratUpgrades;
            for (var i = 0; i < zigguratUpgrades.length; i++){
                var upgr = zigguratUpgrades[i];

                var button = $r(WBuildingBtn, {
                    id:         upgr.name,
                    name: upgr.label,
                    description: upgr.description,
                    prices: upgr.prices,
                    controller: zigguratController,
                    handler: upgr.handler
                });

                zuButtons.push(button);
            }
        }   //eo zg upgrades


        var ruButtons = [];

        if (game.challenges.currentChallenge != "atheism") {
            //------------------- religion -------------------
            var religion = game.religion;
            if (religion.faith) {
                var faithText = $I("religion.faithCount.pool",[game.getDisplayValueExt(religion.faith)]);
                var bonus = religion.getProductionBonus();
                if (bonus != 0) {
                    faithText += ( " (+" + game.getDisplayValueExt(bonus) + "% " + $I("religion.faithCount.bonus") + ")" );
                }
                ruButtons.push( $r("span", { 
                    style: { 
                        display: "inline-block", 
                        marginBottom: "10px"
                    }
                }, faithText ));
            }

            if (religion.getRU("apocripha").on){
                //----------------------- reset -----------------------
                var faithResetBtn = $r(WBuildingBtn, {
                    name: "Reset the total pool",
                    description: "Reset the total pool and boost the faith grow",
                    controller: new com.nuclearunicorn.game.ui.ButtonModernController(game),
                    handler: function(model, event){
                        this.game.religionTab.resetFaith(event);    
                    },
                    mainButtonTitle: $I("btn.reset")
                });

                ruButtons.push(faithResetBtn);
            }
            

            var praiseBtn = $r(WBuildingBtn, {
                name: $I("religion.praiseBtn.label"),
                description: $I("religion.praiseBtn.desc"),
                controller: new com.nuclearunicorn.game.ui.PraiseBtnController(game),
                handler: function(){
                    this.game.religion.praise();    //sigh, enjoy your automation scripts
                },
                mainButtonTitle: $I("btn.praise")
            });
            ruButtons.push(praiseBtn);

            var controller = new com.nuclearunicorn.game.ui.ReligionBtnController(game);
            var upgrades = game.religion.religionUpgrades;
            for (var i = 0; i < upgrades.length; i++){
                var upgr = upgrades[i];

                var button = $r(WBuildingBtn, {
                    id:         upgr.name,
                    name:       upgr.label,
                    description: upgr.description,
                    prices: upgr.prices,
                    controller: controller,
                    handler: function(btn){
                        var upgrade = btn.model.metadata;
                        if (upgrade.upgrades){
                            game.upgrade(upgrade.upgrades);
                        }
                    }
                });
                ruButtons.push(button);
            }

            var transcendBtn = $r(WButtonModern, {
                name: $I("religion.transcendBtn.label"),
                description: $I("religion.transcendBtn.desc"),
                controller: new com.nuclearunicorn.game.ui.TranscendBtnController(game),
                handler: function(btn) {
                    game.religion.transcend();
                    var transcendenceLevel = game.religion.getTranscendenceLevel();
                    for (var i = 0; i < game.religion.transcendenceUpgrades.length; i++) {
                        if (transcendenceLevel >= game.religion.transcendenceUpgrades[i].tier) {
                            game.religion.transcendenceUpgrades[i].unlocked = true;
                        }
                    }
                },
                mainButtonTitle: $I("religion.transcendBtn.label")
            });

            ruButtons.push(transcendBtn);
        }

        var cryptButtons = [];
        var hasCT = game.science.get("cryptotheology").researched && game.religion.tclevel > 0;
        if (hasCT){
            var transcendenceController = classes.ui.TranscendenceBtnController(game);
            dojo.forEach(game.religion.transcendenceUpgrades, function(tu, i){
                var button = $r(WBuildingBtn, {
                    id:         tu.name,
                    name:       tu.label,
                    description: tu.description,
                    controller: transcendenceController
                });
                cryptButtons.push(button);
            });
        }


        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", {},
                [
                    zuButtons.length? $r(WCollapsibleSection, {
                        title: $I("religion.panel.ziggurat.label"),
                        collapsed: false,
                        type: "button-group"
                    }, [
                        (game.resPool.get("sorrow").value > 0 ) ? $r("div", null, 
                            $r("span", {className: "kg-instructional-text"}, 
                                "BLS:" + (game.resPool.get("sorrow").value) + "%"
                            )
                        ): null,
                        twoRows? TwoInRowHelper.layout(zuButtons, false) : zuButtons
                    ]): null,
                    $r(WCollapsibleSection, {
                        title: $I("religion.panel.orderOfTheSun.label"),
                        collapsed: false,
                        type: "button-group"
                    }, [
                        twoRows? TwoInRowHelper.layout(ruButtons, true) : ruButtons
                    ]),
                    hasCT? $r(WCollapsibleSection, {
                        title: $I("religion.panel.cryptotheology.label"),
                        collapsed: false,
                        type: "button-group"
                    }, [
                        twoRows? TwoInRowHelper.layout(cryptButtons, false) : cryptButtons
                        
                    ]) : null
                ]
            )
        );
    }
});