

WScienceTab = React.createClass({
    displayName: "WScienceTab",
    
    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },

    render: function() {
        var twoRows = false;
        //1020px or more
        if (!this.props.media.maxWidth760 && !this.props.media.maxWidth320) {
            twoRows = true;
        }

        var techButtons = [];

        techButtons.push(
            $r(WButton, {
                key:   "toggleBtn",
                title: $I("ui.toggle.researched"),
                onclick: this.toggleResearchedTechs
            })
        );
        var controller = new com.nuclearunicorn.game.ui.TechButtonController(game);
        for (var i in game.science.techs){
            var tech = game.science.techs[i];
            var model = controller.fetchModel({id: tech.name, controller: controller, twoRows:twoRows});
            if (!model.visible) {
                continue;
            }

            techButtons.push($r(WBuildingBtn, {
                key: tech.name,
                model: model,
                mainButtonTitle: $I("btn.research"),
                controller: controller
            }));
        }

        var sections = [];
        sections.push(
            $r(WCollapsibleSection, {
                title: $I("techs.panel.label"),
                collapsed: false,
                type: "button-group"
            }, [
                twoRows? TwoInRowHelper.layout(techButtons, true) : techButtons
            ])
        );

        var showMetaphysics = game.science.get("metaphysics").researched && game.resPool.get("paragon").value > 0;
        if (!showMetaphysics){
            for (var i = game.prestige.perks.length - 1; i >= 0; i--){
                var perk = game.prestige.perks[i];
                if (perk.researched){
                    showMetaphysics = true;
                    break;
                }
            }
        }

        if (showMetaphysics) {
            var buttonBP = $r(WButtonModern, {
                name : $I("prestige.btn.burnParagon.label"),
                description: $I("prestige.btn.burnParagon.desc"),
                handler: dojo.hitch(this, function(){
                    game.discardParagon();
                }),
                controller: new classes.ui.BurnParagonBtnController(game),
                mainButtonTitle: $I("prestige.btn.burnParagon.label")
            });
            var metaButtons = [];

            metaButtons.push(buttonBP);
            
            //---------------------------------------------------------------------
            var prestigeController = new classes.ui.PrestigeBtnController(game);
            dojo.forEach(game.prestige.perks, function(perk, i) {
                var model = prestigeController.fetchModel({id: perk.name, controller: prestigeController});
                if (!model.visible) {
                    return;
                }

                metaButtons.push($r(WButtonModern, {
                    key: perk.name,
                    model: model,
                    controller: prestigeController, 
                    mainButtonTitle: $I("btn.research")
                }));
            });

            sections.push(
                $r(WCollapsibleSection, {
                    title: $I("prestige.panel.label"),
                    type: "button-group"
                }, [
                    twoRows? TwoInRowHelper.layout(metaButtons, false) : metaButtons
                ])
            );
        }

        var showChallenges = game.prestige.getPerk("adjustmentBureau").researched;
        if (showChallenges){

            var challengeButtons = [];
            // dojo.forEach(game.challenges.challenges, function(challenge, i){
            //     challengeButtons.push(
            //         $r(WChallengeButton, {meta: challenge})
            //     );
            // });

            var challengeController = new classes.ui.ChallengeBtnController(game);
            dojo.forEach(game.challenges.challenges, function(challenge, i){
                challengeButtons.push(
                    $r(WBuildingBtn, {
                        key: challenge.name,
                        id: challenge.name, 
                        controller: challengeController,
                        mainButtonTitle: $I("btn.challenge")
                    })
                );
            });

            sections.push(
                $r(WCollapsibleSection, {
                    title: $I("challendge.panel.label"),
                    type: "button-group"
                }, [
                    twoRows? TwoInRowHelper.layout(challengeButtons, false) : challengeButtons
                ])
            );
        }
        //-------------------------

        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", {},
                [
                    sections
                ]
            )
        );
    },

    toggleResearchedTechs: function(){
        game.science.hideResearched = !game.science.hideResearched;
        game.render();
        //this.setState({hideResearched: !this.state.hideResearched})
    }
});