
WSpaceTab = React.createClass({
    displayName: "WSpaceTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },
    
    render: function() {
        var twoRows = false;
        //1020px or more
        if (!this.props.media.maxWidth760 && !this.props.media.maxWidth320) {
            twoRows = true;
        }
        var sections = [];
        var gcButtons = [];

        gcButtons.push(
            $r(WButton, {
                title: $I("ui.toggle.researched"),
                onclick: this.toggleResearchedTechs
            })
        );

        var controller = new com.nuclearunicorn.game.ui.SpaceProgramBtnController(game);
        dojo.forEach(game.space.programs, function(program, i){
            var model = controller.fetchModel({id: program.name, controller: controller, twoRows:twoRows});
            if (!model.visible) {
                return;
            }
            var button = $r(WBuildingBtn, {
                key: program.name,
                model: model,
                controller: controller, 
                mainButtonTitle: $I("btn.research")
            });
            gcButtons.push(button);
        });

        //------------ space space I'm in space -------------

        sections.push($r(WCollapsibleSection, {
                title: $I("space.ground.control.label"),
                collapsed: false,
                type: "button-group"
            }, twoRows? TwoInRowHelper.layout(gcButtons, true) : gcButtons)
        );

        dojo.forEach(game.space.planets, function(planet, i){
            if (planet.unlocked){
                var planetTitle = "";
                if (game.prestige.getPerk("numerology").researched) {
                    
                    dojo.forEach(game.calendar.cycles, function(cycle, i){
                        if (cycle.name == planet.name || (planet.name == "moon" && cycle.name == "redmoon")) {
                            planetTitle += cycle.glyph + " ";
                        }
                    });
                    planetTitle += planet.label;
                } else {
                    planetTitle = planet.label;
                }

                var planetBldButtons = [];
                var controller = new classes.ui.space.PlanetBuildingBtnController(game);
                dojo.forEach(planet.buildings, function(building, i){
                    planetBldButtons.push($r(WBuildingBtn, {
                        id: building.name, 
                        key: building.name,
                        planet: planet, 
                        controller: controller
                    }));
                });

                sections.push($r(WCollapsibleSection, {
                        titleHTML: planetTitle,
                        collapsed: true,
                        type: "button-group"
                    }, twoRows? TwoInRowHelper.layout(planetBldButtons, false) : planetBldButtons)
                );
            }
        });


        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", {},
                [
                    sections
                ]
            )
        );
    },

    toggleResearchedTechs: function(){
        game.space.hideResearched = !game.space.hideResearched;
        game.render();
        //this.setState({hideResearched: !this.state.hideResearched})
    }
});
