WStatsTab = React.createClass({
    displayName: "WStatsTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },
    
    render: function() {

        var groups = [];
        for (var idx in game.stats.statGroups) {
            var statGroup = game.stats.statGroups[idx];

            var statsBlock = [];

            var stats = statGroup.group;
            for (var i in stats) {
                var stat = stats[i];

                if (stat.calculate) {
                    stat.val = stat.calculate(game);
                }

                if (stat.val > 0) {
                    stat.unlocked = true;
                }

                statsBlock.push($r("div", { className: "stats-row"},
                    $r("div", {className: "stats-name"}, stat.unlocked ? stat.title : "???"),
                    $r("div", {className: "stats-val"}, stat.unlocked ? game.getDisplayValueExt(stat.val) : "")
                ));
            }

            groups.push(
                $r(WCollapsibleSection, {
                    title: statGroup.title,
                    collapsed: false
                }, [
                    statsBlock
                ])
            );
        }


         return  $r("div", {className: "list-block accordion-list"},[
            groups
         ]);
    }
});