
WShatterTCBtn = React.createClass({
    displayName: "WShatterTCBtn",
    render: function(){
        ButtonUtils.fetchModel(this);
        
        return $r(WButtonModern, {
            controller: this.controller,
            model: this.model,
            mainButtonTitle: $I("time.shatter.tc"),
            subButtons: [this.model.x5Link]
        });
    }
});

WTimeTab = React.createClass({
    displayName: "WTimeTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },
    
    render: function() {

        var resetInfo = $I("time.reset.instructional") + "<br>";

        var kittens = game.resPool.get("kittens").value;
        var stripe = 5;
        var karmaPointsPresent = game.getTriValue(game.karmaKittens, stripe);
        var karmaPointsAfter = game.getTriValue(game.karmaKittens + game._getKarmaKittens(kittens), stripe);
        var karmaPoints = Math.floor((karmaPointsAfter - karmaPointsPresent) *100)/100;
        var paragonPoints = 0;

        if (kittens > 70){
            paragonPoints = (kittens - 70);
        }

        resetInfo += $I("time.reset.karma") + ": " + karmaPoints;
        resetInfo += "<br>" + $I("time.reset.paragon") + ": " + paragonPoints;

        if (game.ironWill){
            resetInfo += "<br>" + $I("time.reset.zebra") + ": " + game._getBonusZebras();
        }

        var timeSections = [
            /*$r(WCollapsibleSection, {
                title: "Time",
                collapsed: false,
                type: "button-group"
            }, []),*/

            $r(WCollapsibleSection, {
                title: $I("time.reset.title"),
                collapsed: false,
                type: "button-group"
            }, [
                $r("li", {className: "kg-button"},
                    [$r("a", { href: "#", className: "item-link list-button", onClick: this.reset }, $I("btn.reset"))]
                ),
                $r("span", {className: "kg-instructional-text", dangerouslySetInnerHTML: { __html: resetInfo}})
            ])
        ];

        var hasCF = game.workshop.get("chronoforge").researched;
        if (hasCF) {

            var chronoForgeButtons = [
                $r(WShatterTCBtn, {
                    name: $I("time.shatter.tc"),
                    description: $I("time.shatter.tc.desc"),
                    prices: [{name: "timeCrystal", val: 1}],
                    controller: new classes.ui.time.ShatterTCBtnController(game)
                })
            ];

            var chronoforgeController = new classes.ui.time.ChronoforgeBtnController(game);
            for (var i in game.time.chronoforgeUpgrades){
                var meta = game.time.chronoforgeUpgrades[i];

                chronoForgeButtons.push($r(WBuildingBtn, {
                    id: meta.name, 
                    controller: chronoforgeController 
                }));
            }

            var heatInfo = "";

            if (game.workshop.get("chronoforge").researched) {
                heatInfo += $I("time.chronoheat");

                var heatMax = game.getEffect("heatMax");
                if(game.time.heat > heatMax){
                    heatInfo += "<br>" + $I("time.heat") + ": <span style='color:red;'>" + game.time.heat.toFixed(2) + "</span>/" + heatMax;
                } else {
                    heatInfo += "<br>" + $I("time.heat") + ": " + game.time.heat.toFixed(2) + "/" + heatMax;
                }
            }



            timeSections.push(
                $r(WCollapsibleSection, {
                    title: $I("workshop.chronoforge.label"),
                    collapsed: false,
                    type: "button-group"
                }, [
                    $r("span", {className: "kg-instructional-text", dangerouslySetInnerHTML: { __html: heatInfo}}),
                    chronoForgeButtons
                ])
            );
        }

        //----------------------------------------
        var hasVS = (game.science.get("voidSpace").researched || game.time.getVSU("usedCryochambers").val > 0);
        if (hasVS){

            var voidButtons = [
                $r(WButtonModern, {
                    name: $I("time.fixCryochambers.label"),
                    description: $I("time.fixCryochambers.desc"),
                    prices: [
                        {name: "timeCrystal", val: 100},
                        {name: "void", val: 500},
                        {name: "temporalFlux", val: 3000},
                    ],
                    controller: new classes.ui.time.FixCryochamberBtnController(game),
                    mainButtonTitle: $I("btn.fix.cryo")
                })
            ];

            var voidSpaceController = new classes.ui.time.VoidSpaceBtnController(game);
            for (var i in game.time.voidspaceUpgrades){
                var meta = game.time.voidspaceUpgrades[i];

                voidButtons.push($r(WBuildingBtn, {
                    id: meta.name, 
                    controller: voidSpaceController 
                }));
            }

            timeSections.push(
                $r(WCollapsibleSection, {
                    title: $I("time.void"),
                    collapsed: false,
                    type: "button-group"
                }, voidButtons)
            );
        }
        //----------------------------------------


        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", {},
                timeSections
            )
        );
    },

    reset: function(){
        game.reset();
    }
});
