WJobButton = React.createClass({
    displayName: "WJobButton",

    getInitialState: function() {
        return {
            collapsed: true
        };
    },

    componentWillMount: function(){
    },

    render: function(){
        return $r("li", {className: "accordion-item kg-job-button"},
            [
                $r("a", { href: "#", className: "item-content item-link", onClick: this.toggle },
                    $r("div", {className: "item-inner"},
                        $r("div", {className: "item-title"},
                            this.props.meta.title
                            + " (" + this.props.meta.value + ")"
                        )
                    )
                ),
                $r("div", {className: "accordion-item-content"},
                    $r("div", {className: "content-block"}, [
                            $r("span", {}, this.props.meta.description),

                            //----------- +1 -1 buttons
                            $r("div", { className: "bld-tooltip-buttons"}, [
                                $r("p", { className: "buttons-row"},
                                    [
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 1, onClick: this.assignJob}, "+1"),
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 5, onClick: this.assignJob}, "+5"),
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 25, onClick: this.assignJob}, "+25"),
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 100, onClick: this.assignJob}, "+" + $I("btn.all.minor"))
                                    ]
                                ),
                                $r("p", { className: "buttons-row"},
                                    [
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 1, onClick: this.unassignJob}, "-1"),
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 5, onClick: this.unassignJob}, "-5"),
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 25, onClick: this.unassignJob}, "-25"),
                                        $r("a", { className: "button button-raised", href:"#", 'data-amount': 100, onClick: this.unassignJob}, "-" + $I("btn.all.minor"))
                                    ]
                                )
                            ])
                            //-------------------------------------
                        ]
                    )
                )
            ]
        );
    },

    assignJob: function(e){
        var amt = e.target.dataset.amount;
        var job = game.village.getJob(this.props.meta.name);
        console.log("assigning job: " + job.name);

        for (var i = amt - 1; i >= 0; i--) {
            game.village.assignJob(job);
        }
    },

    unassignJob: function(e){
        var amt = e.target.dataset.amount;
        var job = game.village.getJob(this.props.meta.name);
        console.log("unassigning job: " + job.name);

        if (job.value < amt){
            amt = job.value;
        }

        for (var i = amt - 1; i >= 0; i--) {
            game.village.sim.removeJob(job.name);
        }
    }
});

WCensusBtn = React.createClass({
    getDefaultProps: function() {
        return {
            kitten: null,
            census: null
        };
    },
    render: function() {
        var kitten = this.props.kitten;
        return $r("li", {className: "accordion-item kg-job-button"},
            [
                $r("a", { href: "#", className: "item-content item-link", onClick: this.toggle },
                    $r("div", {className: "item-inner"},
                        $r("div", {
                            className: "item-title" + (this.props.kitten.isLeader ? " census-leader" : "")
                            }, 
                            (this.props.kitten.isLeader ? "★" : "") + kitten.name + " " + kitten.surname
                        )
                    )
                ),
                $r("div", {className: "accordion-item-content"},
                    $r("div", {className: "content-block"}, [
                            $r("span", {dangerouslySetInnerHTML: { __html:
                                kitten.age + " " + $I("village.census.age") + ", "
                                + kitten.trait["title"]
                                + (kitten.rank == 0 ? "" : " (" + $I("village.census.rank") + " " + kitten.rank + ")")
                                + "<br>"
                                + this.props.census.getSkillInfo(kitten)
                            }}),

                            $r("div", { className: "bld-tooltip-buttons"}, [
                                $r("p", { className: "buttons-row"},
                                    [
                                        $r("a", { className: "button button-raised", href:"#", onClick: this.promote}, $I("btn.promote")),
                                        $r("a", { className: "button button-raised", href:"#", onClick: this.unassign}, $I( "village.btn.unassign.job")),
                                        $r("a", { className: "button button-raised", href:"#", onClick: this.makeLeader}, $I("btn.leader"))
                                    ]
                                )
                            ])
                            //-------------------------------------
                        ]
                    )
                )
            ]);
    },

    makeLeader: function(){
        this.props.census.makeLeader(this.props.kitten);
    },

    promote: function(){
        game.village.sim.promote(this.props.kitten);
    },

    unassign: function(){
        game.village.unassignJob(this.props.kitten);
    }
});

//this is ugly, but one step at a time
WCensusSection = React.createClass({
    censusLegacy: null,

    getInitialState: function() {
        this.censusLegacy = new classes.ui.village.Census(game);
        return {
            page: 0
        };
    },

    render: function() {
        var govInfo = this.censusLegacy.getGovernmentInfo();

        var censusBtns = [];
        var sim = game.village.sim;
        this.censusLegacy.sortKittensByExp(sim.kittens);

        var kittensLimit = 0;
        for (var i = (sim.kittens.length - 1) - (this.state.page * 5); i >= 0 && kittensLimit < 5; i--) {
            censusBtns.push($r(WCensusBtn, {kitten: sim.kittens[i], census: this.censusLegacy}));
            kittensLimit++;
        }

        return $r("div",{},
            [$r("div", {
                className: "kg-instructional-text",
                dangerouslySetInnerHTML: { __html: "<strong>" + $I("village.census.lbl.leader") + ":</strong> " + govInfo.leaderInfo }
            }),
                censusBtns,
                sim.kittens.length > 5 ? $r("div", { className: "bld-tooltip-buttons"}, [
                    $r("span", { className: "kg-instructional-text"}, $I("village.census.page", [( this.state.page + 1 ), (Math.round(sim.kittens.length / 5) + 1)])),
                    $r("p", { className: "buttons-row"},
                        [
                            $r("a", { className: "button button-raised", href:"#", onClick: this.prevPage}, $I("btn.prevPage")),
                            $r("a", { className: "button button-raised", href:"#", onClick: this.nextPage}, $I("btn.nextPage"))
                        ]
                    )
                ]) : null
            ]
        );
    },

    nextPage: function(){
        var page = this.state.page + 1;
        var maxPages = Math.round(game.village.sim.kittens.length / 5);
        if (page > maxPages){
            page = maxPages;
        }
        this.setState({page:page});
    },

    prevPage: function(){
        var page = this.state.page - 1;
        if (page < 0){
            page = 0;
        }
        this.setState({page : page});
    }
});

WVillageTab = React.createClass({
    displayName: "WVillageTab",
    happinessToolbarLegacy : null,

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function(){
        this.happinessToolbarLegacy = new classes.ui.toolbar.ToolbarHappiness(game);
        return {
            game: game,
            censusSectionCollapsed: false
        };
    },

    render: function() {

        var jobButtons = [];

        for (var i = 0; i < game.village.jobs.length; i++){
            var job = game.village.jobs[i];

            if (!job.unlocked){
                continue;
            }

            var btn = this.createJobBtn(job, game);

            jobButtons.push(btn);
        }

        var happiness = game.village.happiness * 100;

        var sim = game.village.sim;
        var progress = "";
        if (sim.nextKittenProgress && sim.maxKittens <= 10 ){
            progress += " [" + ( sim.nextKittenProgress * 100 ).toFixed()  + "%]";
        }

        var jobsTitle = $I("village.freeKittens") + ": " + game.village.getFreeKittens() +
            " / <span class='village-kittens-total'>" + game.resPool.get("kittens").value + "</span>" +progress;

        var huntBtn = null;

        if (game.science.get("archery").researched){
            huntBtn = $r(WButtonModern, {
                name:       $I("village.btn.hunters"),
                controller: new classes.village.ui.VillageButtonController(game),
                handler:    function(btn){
                    game.village.sendHunters();
                },
                description: $I("village.btn.hunters.desc"),
                prices: [{ name : "manpower", val: 100 }],
                mainButtonTitle: $I("village.btn.hunters"),
                showTooltip: game.resPool.get("kittens").value <= 20
            });
        }

        //console.log(this.happinessToolbarLegacy, this.happinessToolbarLegacy.getTooltip());

        var hasCensus = game.science.get("civil").researched;
        var censusSection = null;

        if (hasCensus){
            censusSection = $r(WStatelessCollapsibleSection, {
                    title: $I("village.panel.census"),
                    collapsed: this.state.censusSectionCollapsed,
                    //type: "button-group",
                    ontoggle: this.toggleCensusSection
                },
                $r(WCensusSection)
            );
        }

        var hasFestivals = game.science.get("drama").researched,
            festivalDays = game.calendar.festivalDays;

        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", {},
               [
                   $r(WCollapsibleSection, {
                       titleHTML: jobsTitle,
                       collapsed: false//,
                       //type: "button-group"
                   }, [
                       jobButtons
                   ]),

                   //----------------------------
                   censusSection,

                   $r(WCollapsibleSection, {
                        title: $I("village.census.lbl.happiness") + ":" + Math.floor(happiness) + "%",
                        collapsed: false
                   },[
                       $r("span", {
                           className: "kg-instructional-text",
                           dangerouslySetInnerHTML: { __html: $I("village.panel.management.desc") + "<br><br>" }
                       }),
                       $r("span", {
                           className: "kg-instructional-text",
                           dangerouslySetInnerHTML: { __html: this.happinessToolbarLegacy.getTooltip() }
                       }),
                       huntBtn,
                       festivalDays ? $r("span", {
                           className: "kg-instructional-text",
                           dangerouslySetInnerHTML: { __html: "<br>" + $I("village.census.lbl.festival.duration") + ": " + game.toDisplayDays(festivalDays) + "<br><br>" }
                       }) : null,
                       hasFestivals ? $r(WButtonModern, {
                           name:       $I("village.btn.festival"),
                           controller: new classes.village.ui.FestivalButtonController(game),
                           handler:    function(btn){
                               game.village.holdFestival(1);
                           },
                           description: $I("village.btn.festival.desc"),
                           prices: [
                               { name : "manpower", val: 1500 },
                               { name : "culture", val: 5000 },
                               { name : "parchment", val: 2500 }
                           ],
                           mainButtonTitle: $I("village.btn.festival"),
                           showTooltip: true    //TODO: figure out some tooltip stopper
                       }) : null,
                       //---------- optimize ------------
                       $r(WButtonModern, {
                           name:       $I("village.btn.manage"),
                           controller: new classes.village.ui.VillageButtonController(game, {
                               updateVisible: function (model) {
                                   model.visible = game.village.leader != undefined && game.workshop.get("register").researched && game.challenges.currentChallenge != "anarchy";
                               }
                           }),
                           handler:    function(btn){
                               this.game.village.optimizeJobs();
                           },
                           description: $I("village.btn.manage.desc"),
                           mainButtonTitle: $I("village.btn.manage"),
                           showTooltip: true
                       }),
                       //---------- promote ------------
                       $r(WButtonModern, {
                           name:       $I("village.btn.promote"),
                           handler: dojo.hitch(this, function(){
                               game.village.promoteKittens();
                           }),
                           controller: new classes.village.ui.VillageButtonController(game, {
                               updateVisible: function (model) {
                                   model.visible = game.village.leader != undefined && game.workshop.get("register").researched && game.challenges.currentChallenge != "anarchy";
                               }
                           }),
                           description: $I("village.btn.promote.desc"),
                           mainButtonTitle: $I("village.btn.promote"),
                           showTooltip: true
                       })
                   ])
               ]
            )
        );
    },

    toggleCensusSection: function(){
        this.setState({
            censusSectionCollapsed: !this.state.censusSectionCollapsed
        });
    },

    createJobBtn: function(job, game){
        return $r(WJobButton, {
            meta: job
        });
    }
});