WCraftPanel = React.createClass({
    render: function() {
        var hasEngineers = game.science.get("mechanization").researched;

        return $r(WCollapsibleSection, {
            title: $I("workshop.craftPanel.label"),
            type: "button-group",
            collapsed: false
        }, [
            $r("div", null, 
                $r("span", {className: "kg-instructional-text"}, 
                    $I("workshop.craft.effectiveness", [(game.getCraftRatio() * 100).toFixed(0)])
                )
            ),
            hasEngineers ? $r("div", {}, $I("workshop.craftPanel.header.freeEngineers") + ": " + game.village.getFreeEngineer() + " / " + game.village.getWorkerKittens("engineer")) : null,
            this.props.buttons
        ]);
    }
});

WWorkshopTab = React.createClass({
    displayName: "WWorkshopTab",

    mixins: [GameUpdateTrackerMixin],

    onGameUpdate: function(game) {
        this.setState({
            game: game
        });
    },

    getInitialState: function() {
        return {
            game: game
        };
    },

    render: function() {
        var twoRows = false;
        //1020px or more
        if (!this.props.media.maxWidth760 && !this.props.media.maxWidth320) {
            twoRows = true;
        }

        var upgradeButtons = [];
        var craftButtons = [];

        upgradeButtons.push(
            $r(WButton, {
                key: "toggle",
                title: $I("ui.toggle.researched"),
                onclick: this.toggleResearchedUpgrades
            })
        );

        var upgradeController = new com.nuclearunicorn.game.ui.UpgradeButtonController(game);
        for (var i in game.workshop.upgrades){
            var upgrade = game.workshop.upgrades[i];

            
            var model = upgradeController.fetchModel({id: upgrade.name, controller: upgradeController});
            if (!model.visible) {
                continue;
            }

            upgradeButtons.push($r(WBuildingBtn, {
                key: upgrade.name, 
                model: model,
                controller: upgradeController,
                mainButtonTitle: $I("btn.research")
            }));
        }
        var craftPanelVisible = game.science.get("construction").researched;
        if (craftPanelVisible) {
            var craftController = new com.nuclearunicorn.game.ui.CraftButtonController(game, {compactStyle: true});
            for (var i in game.workshop.crafts){
                var craft = game.workshop.crafts[i];

                var model = craftController.fetchModel({
                    name: craft.label,
                    description: craft.description,
                    craft: craft.name,
                    prices: game.workshop.getCraftPrice(craft),
                    compact: true,
                    controller: craftController
                });

                if (!model.visible) {
                    continue;
                }
                var subButtons = model.assignCraftLinks.concat(model.unassignCraftLinks);
                
                craftButtons.push(
                    $r(WBuildingBtn, {
                        key: craft.name,
                        model: model,
                        controller: craftController,
                        mainButtonTitle: $I("btn.craft"),
                        subButtons: subButtons 
                    })
                );
            }
        }

        return  $r("div", {className: "list-block accordion-list"},
            $r("ul", {},
                [
                    $r(WCollapsibleSection, {
                        title: $I("workshop.upgradePanel.label"),
                        collapsed: false,
                        type: "button-group"
                    }, [
                        twoRows? TwoInRowHelper.layout(upgradeButtons, true) : upgradeButtons
                        
                    ]),
                    craftPanelVisible? $r(WCraftPanel, {buttons: twoRows? TwoInRowHelper.layout(craftButtons, false) : craftButtons}) : null
                ]
            )
        );
    },

    toggleResearchedUpgrades: function(){
        game.workshop.hideResearched = !game.workshop.hideResearched;
        game.render();
        //this.setState({hideResearched: !this.state.hideResearched})
    }
});