WSubnavTabs = React.createClass({

    displayName: "WSubnavTabs",
    getDefaultProps: function() {
        return {
            tabs: [],
            selectedTabId: null,
            onclick: null
        };
    },

    render: function() {
        var tabBtns = [],
            self = this;

        for (var i in this.props.tabs){
            var tab = this.props.tabs[i];

            if (!tab.visible){
                continue;
            }

            var selectedClass = "";
            if (tab.tabId == this.props.selectedTabId){
                selectedClass += " active";
            }

            tabBtns.push(
                $r("div", {
                    href:"#",
                    className: "button tab" + selectedClass,
                    'data-tab-id': tab.tabId,
                    onClick: this.onClick
                }, tab.tabName)
            );
        }
        return $r("div", {className: "kg-subnav-menu"},
            $r("div", {className: "buttons-row tabs-row"},[
                tabBtns
            ])
        );
    },

    onClick: function(tabId){
        this.props.onclick(event.target.dataset.tabId);
    }
});

/**
 * Mark 3 implementation of the menu which can be collapsed up and down
 */
WSubnavTabsSlidedown = React.createClass({
    displayName: "WSubnavTabsSlidedown",

    getDefaultProps: function() {
        return {
            tabs: [],
            selectedTabId: null,
            onTabClick: null,
            onTitleClick: null,
            onToggleClick: null,
            collapsed: false
        };
    },

    getInitialState: function() {
        return {
            collapsed: this.props.collapsed !== undefined ? this.props.collapsed : true
        }
    },

    render: function() {
        var tabBtns = [],
            self = this,
            selectedTab = $dd.get(this.props.tabs, this.props.selectedTabId, "tabId");

        for (var i in this.props.tabs){
            var tab = this.props.tabs[i];

            if (!tab.visible){
                continue;
            }

            var selectedClass = "";
            if (tab.tabId == this.props.selectedTabId){
                selectedClass += " active";
            }

            var tabName = ("getTabName" in tab) ? tab.getTabName() : tab.tabName;

            tabBtns.push(
                $r("div", {
                    href:"#",
                    className: "button kg-menu-button tab" + selectedClass,
                    'data-tab-id': tab.tabId,
                    onClick: this.onClick
                }, tabName )
            );
        }

        //do not render redundant button if this is the only tab
        if (tabBtns.length < 2){
            return $r("div", { className: "title-truncated ", onClick: this.props.onTitleClick}, selectedTab.tabName );
        }

        var maxWidth320 = window.matchMedia("(max-width: 320px)");
        return $r(WStatelessCollapsibleSection, {
                title: selectedTab.tabName,
                _title: {
                    onClick: !maxWidth320.matches  ? this.onToggle760_ : this.props.onTitleClick,
                    className: "tabnav"
                },
                collapsed: this.props.collapsed,
                type: "menu",
                ontoggle: !maxWidth320.matches ? this.props.onTitleClick : this.onToggle
            }, [
                tabBtns
            ]);
    },

    onClick: function(event){
        this.props.onTabClick(event.target.dataset.tabId);
    },

    onToggle760_: function(){
        this.setState({
            collapsed: !this.state.collapsed
        });
        this.onToggle(!this.state.collapsed);
    },

    onToggle: function(isCollapsed){
        /* UGLY HACK */
        $(".resources-page").toggleClass("navbar-collapsed", isCollapsed);
        this.props.onToggleClick(isCollapsed);
    }
});

WCalendar = React.createClass({ 
    displayName: "WCalendar",

    mixins: [React.PureComponent],

    subscribeHander: null,

    getInitialState: function() {
        return {
            calendarText: ""
        };
    },

    componentDidMount: function() {
        var self = this;
        this.subscribeHander = dojo.subscribe("calendar/update", function(calendarText) {
            setTimeout(dojo.hitch(self, dojo.partial(self.onChange, calendarText)), 0);
        });
    },

    componentWillUnmount: function() {
        if (this.subscribeHander) {
            dojo.unsubscribe(this.subscribeHander);
        } 
    },

    onChange: function(calendarText){
        this.setState({
            calendarText: calendarText
        });
    },

    render: function() {
        return $r("div", {className: "calendar"},[
            this.state.calendarText
        ]);
    }
});



WViewport = React.createClass({
    displayName: "WViewport",

    //mixins: [WhyDidYouUpdateMixin],

    media: null, 

    getDefaultProps: function() {
        return {
            tabs: [
                { id:"Bonfire",       class: WBonfireTab    },
                { id:"Village", class: WVillageTab    },
                { id:"Science",       class: WScienceTab    },
                { id:"Workshop",      class: WWorkshopTab   },
                { id:"Trade",         class: WDiplomacyTab  },
                { id:"Religion",      class: WReligionTab   },
                { id:"Space",         class: WSpaceTab      },
                { id:"Time",          class: WTimeTab       },
                { id:"Achievements",  class: WAchieventsTab },
                { id:"Stats",         class: WStatsTab      }
            ]
        };
    },

    getInitialState: function() {
        return {
            selectedTabId: "Bonfire",
            resourceCollapsed: true,
            media: null
        };
    },

    componentDidMount: function() {
        var self = this;
        //TODO: rename event to something like 'viewportChanged'
        this.subscribeHander = dojo.subscribe("server/undoStateChanged", function() {
            self.setState(self.state);
        });
    },

    componentWillUnmount: function() {
        if (this.subscribeHander) {
            dojo.unsubscribe(this.subscribeHander);
        }
    },

    componentWillMount: function() {
        try {
            //@media (max-width: 1520px) 
            //@media (max-width: 760px) 
            //@media (max-width: 320px)
            var maxWidth1520 = window.matchMedia("(max-width: 1520px)");
            maxWidth1520.addListener(dojo.hitch(this, dojo.partial(this.onMediaChange, 'maxWidth1520')) );

            var maxWidth1020 = window.matchMedia("(max-width: 1020px)");
            maxWidth1020.addListener(dojo.hitch(this, dojo.partial(this.onMediaChange, 'maxWidth1020')) );

            var maxWidth760 = window.matchMedia("(max-width: 760px)");
            maxWidth760.addListener(dojo.hitch(this, dojo.partial(this.onMediaChange, 'maxWidth760')) );

            var maxWidth320 = window.matchMedia("(max-width: 320px)");
            maxWidth320.addListener(dojo.hitch(this, dojo.partial(this.onMediaChange, 'maxWidth320')) );

            this.media = {
                'maxWidth1520': maxWidth1520.matches,
                'maxWidth1020': maxWidth1020.matches,
                'maxWidth760': maxWidth760.matches,
                'maxWidth320': maxWidth320.matches
            };

            this.setState({
                selectedTabId: this.state.selectedTabId,
                resourceCollapsed: this.state.resourceCollapsed,
                tabnavCollapsed: this.state.tabnavCollapsed,
                media: dojo.clone(this.media)
            });
        } catch(e) {
            console.log(e.stack);
        }
    },


    onMediaChange: function(name, mql) {
        this.media[name] = mql.matches;
        this.setState({
            selectedTabId: this.state.selectedTabId,
            resourceCollapsed: this.state.resourceCollapsed,
            tabnavCollapsed: this.state.tabnavCollapsed,
            media: dojo.clone(this.media)

        });
        console.log("Media has changed media["+name+"]="+ this.media[name]);
        // if you disable something then it will be changed later.
    },


    render: function() {
        var selectedTab = $dd.get(this.props.tabs, this.state.selectedTabId);

        var viewportContent = [];
        var resCollapsedClass = this.state.resourceCollapsed ? " collapsed" : "";

        var devmodeOpt = game.devMode ? $r("a", { href: "#", className: "item-link list-button", onClick: this._enableDevMode}, "Dev Mode") : null;

        viewportContent = viewportContent.concat([
            $r("div", {className: "panel-overlay"}),
            $r("div", {className: "panel panel-right panel-cover kg-menu"}, [
                $r("div", {className: "list-block"},
                    $r("ul", {},
                        $r("a", { href: "#", className: "item-link list-button kg-menu-close-button", onClick: fw7App.closePanel}, $I("menu.close"))
                    )
                ),
                $r("div", {className: "list-block accordion-list"},
                    $r("ul", {},[
                        $r("a", { href: "#", className: "item-link list-button", onClick: this._save}, $I("menu.save")),
                        $r("a", { href: "#", className: "item-link list-button open-popup", "data-popup": ".popup-import"}, $I("menu.import")),
                        $r("a", { href: "#", className: "item-link list-button open-popup", "data-popup": ".popup-export", onClick: this._export}, $I("menu.export")),
                        $r("a", { href: "#", className: "item-link list-button", onClick: this._loadOptionsPage}, $I("menu.options")),
                        $r("a", { href: "#", className: "item-link list-button", onClick: this._reset}, $I("menu.reset")),
                        $r("a", { href: "#", className: "item-link list-button", onClick: this._wipe}, $I("menu.wipe")),
                        game.undoChange ?
                            $r("a", { href: "#", className: "item-link list-button", onClick: this._undo}, $I("menu.undo"))
                            : null,
                        $r("a", { href: "#", className: "item-link list-button open-popup", "data-popup": ".popup-about"}, $I("menu.about")),
                        devmodeOpt
                    ])
                )
            ]),
            $r("div", {className: "view view-left" + resCollapsedClass},[
                $r("div", {className: "navbar slidedown"}, [
                    $r("div", {className: "kg-subnavbar-slidedown"}, [
                        ((!this.state.media || this.state.media.maxWidth760) ? $r(WSubnavTabsSlidedown,{
                            tabs: this.getTabs(),
                            onTabClick: this.setTab,
                            onTitleClick: this.toggleResourcesSlider,
                            onToggleClick: this.onToggleTabNav,
                            collapsed: this.state.tabnavCollapsed,
                            selectedTabId: this.state.selectedTabId
                        }) : null)
                    ])
                ]),
                $r("div", {className: "pages"},[
                    $r(WResourceSlider, {
                        collapsed: this.state.resourceCollapsed
                    })
                ])
            ])
        ]);

        /*var observeLink = game.ui.observeHandler ?
            $r("a", {href : "#", className: "link", onClick: game.ui.observeHandler, style: {visibility: game.ui.observeHandler ? "visible" : "hidden"}}, "Observe") : null;*/

        viewportContent = viewportContent.concat([
            $r("div", {className: "view view-main navbar-through", onClick: this.mainClick},[
                $r("div", {className: "navbar"}, [
                    $r("div", {className: "navbar-inner"}, [
                        $r("div", {className: "left"}, [
                            $r("a", {href: "#",
                                    className: "link res-toggle-link-main",
                                    onClick: this.toggleResourcesSlider
                                },
                                $r("i", {className: "icon icon-bars"}),
                                $r("span", {}, "")
                            )
                        ]),
                        $r("div", {className: "center sliding title"}, [
                            $I("navbar.title"),
                            /*$r("span", {id: "version", style: {paddingLeft: "11px"}}, "Ver 1.0")*/
                        ]),
                        $r("div", {className: "right"}, [
                            $r("a", {href: "#",
                                    className: "link open-panel",
                                    "data-panel":"right"
                                },
                                //$r("i", {className: "icon icon-bars"}),
                                $r("span", {}, $I("navbar.menu.title"))
                            )
                        ])
                    ])
                ]),
                $r("div", {className: "pages"},[
                    $r("div", {
                        className: "page toolbar-fixed",
                        "data-page": "index-left"
                    }, [
                        /* -----------------------------------------
                         * Tabs section goes there.
                         * TODO: hide for smaller screen resolution, use carousel
                         * TODO: use dynamic tab rendering based on what tab is active
                         ------------------------------------------ */
                        (!this.state.media || !this.state.media.maxWidth760? $r(WSubnavTabs, {
                            tabs: this.getTabs(),
                            onclick: this.setTab,
                            selectedTabId: this.state.selectedTabId
                        }): null),

                        
                        $r("div", {className: "page-content"}, [
                            (!this.state.media || this.state.media.maxWidth1520? $r("div", {className: "calendar-inline-middle"},
                                $r(WCalendar)
                            ) : null),
                            //-------------------------------------------- MID goes there --------------------------
                            selectedTab ? $r(selectedTab.class, {
                                id: this.state.selectedTabId,
                                media: this.state.media
                            }) : "Tab not implemented yet"
                            //--------------------------------------------------------------------------------------
                        ])


                    ])
                ])
            ]),
            $r("div", {className: "view view-right navbar-through"},[
                $r("div", {className: "navbar"}, [
                    $r("div", {className: "navbar-inner"}, [
                        $r("div", {className: "center sliding"}, [
                            //--------------------- RIGHT PANEL HEADER (calendar, menu) ------------------
                            (!this.state.media || !this.state.media.maxWidth760?  $r(WCalendar) : null)
                        ])
                    ])
                ]),
                $r("div", {className: "pages"},[
                    $r("div", {
                        className: "page",
                        "data-page": "index-right"
                    }, [
                        $r("div", {className: "page-content"}, (!this.state.media || !this.state.media.maxWidth1520? [
                            //-------------------------------------------- RIGHT goes there --------------------------
                            $r(WProfiler),
                            $r(WObserveButton), 
                            $r(WLogPreview, {
                                limit: 20
                            })
                        ]: []))
                    ])
                ])
            ])
        ]);



        var viewport =  $r("div", {
            className: "views"
        },[
            viewportContent
        ]);
        return viewport;
    },

    mainClick: function(){
        if (this.state.resourceCollapsed){
            return;
        }
        this.setState({
            selectedTabId: this.state.selectedTabId,
            resourceCollapsed: true,
            tabnavCollapsed: this.state.tabnavCollapsed,
            media: this.state.media
        });

        dojo.publish("ui/toggleResources", [true]);
    },

    createButtons: function(){
        return [];
    },

    getTabs: function(){
        return game.tabs;
    },

    setTab: function(tabId){
        this.setState({
            selectedTabId: tabId,
            resourceCollapsed: (this.state.media && this.state.media.maxWidth320 ? !this.state.resourceCollapsed : this.state.resourceCollapsed),
            tabnavCollapsed: (this.state.media && this.state.media.maxWidth320 ? true : this.state.tabnavCollapsed),
            media: this.state.media
        });
    },

    toggleResourcesSlider: function(){
        var collapsed = !this.state.resourceCollapsed;
        this.setState({
            selectedTabId: this.state.selectedTabId,
            resourceCollapsed: collapsed,
            tabnavCollapsed: this.state.tabnavCollapsed,
            media: this.state.media
        });

        dojo.publish("ui/toggleResources", [collapsed]);
    },

    onToggleTabNav: function(isCollapsed) {
        this.setState({
            selectedTabId: this.state.selectedTabId,
            resourceCollapsed: this.state.resourceCollapsed,
            tabnavCollapsed: isCollapsed,
            media: this.state.media
        });
    },

    _save: function(){
        game.save();
        fw7App.closePanel();

        fw7App.addNotification({
            title: $I("notification.save.title"),
            message: $I("notification.save.desc"),
            hold: 3000,
            closeIcon: false
        });
    },

    _export: function(){
        var saveData = game.save();
        fw7App.closePanel();

        dojo.publish("ui/export", [saveData]);
    },

    _reset: function(){
        game.reset();
    },

    _wipe: function(){
        game.wipe();
    },

    _undo: function(){
        game.undo();
    },

    _loadOptionsPage: function() {
        game.ui.openPopupPage("options");
    },

    _enableDevMode: function(){
        game.unlockAll();
        game.science.unlockAll();
        game.workshop.unlockAll();
        game.diplomacy.unlockAll();
        game.religion.unlockAll();
        game.space.unlockAll();
        game.time.unlockAll();
        game.prestige.unlockAll();
        game.achievements.unlockAll();
        game.stats.unlockAll();
        game.resPool.maxAll();

        dojo.publish("server/undoStateChanged");
    }
});