WButton = React.createClass({
    displayName: "WButton",
    render: function(){
        return $r("li", {className: "kg-button"},
            [ $r("a", { href: "#", className: "item-link list-button", onClick: this.props.onclick }, this.props.title) ]
        );
    }
});

ButtonUtils = {
    fetchModel: function(btn) {
        if (!btn.props.controller) {
            throw new Error("Controller must be defined for the button "+btn);
        }
        btn.controller = btn.props.controller; // for convinience
        btn.model = btn.props.model? btn.props.model: btn.props.controller.fetchModel(btn.props); 
    }
};



AbstractButtonClass = {

    //update: function() {
        // this.model = this.controller.fetchModel(this.opts);
        // this.updateEnabled();
        // this.updateVisible();

        // if (this.buttonTitle && this.buttonTitle.innerHTML != this.model.name){
        //     this.buttonTitle.innerHTML = this.model.name;
        // }
        //TODO How to re-render the button? Or we always need to call game.render()? 
    //},

    animate: function(){
        var btnNode = jQuery(this.props.animateSelector? this.props.animateSelector: this.getDOMNode());
        btnNode.removeClass("pulse-out");
        btnNode.addClass("pulse");

        if (this._animateTimeout){
            clearTimeout(this._animateTimeout);
        }
        this._animateTimeout = setTimeout(function(){
            btnNode.removeClass("pulse");
            btnNode.addClass("pulse-out");
        }, 150);
    },

    onClick: function(event){
        var self = this;
        this.controller.buyItem(this.model, event, function(result) {
            if (result) {
                self.animate();        
                if(self.update) {
                    self.update();
                }
            }
        });

    },
    onHold: function(e){
        if (!this.controller.buyItemAll){
            return;
        }
        this.controller.buyItemAll(this.model, event, function(result) {
            if (result) {
                self.animate();
                if(self.update) {
                    self.update();
                }
            }
        });
    }
};


WSimpleButton = React.createClass({
    displayName: "WSimpleButton",
    mixins: [AbstractButtonClass],

    render: function(){
        ButtonUtils.fetchModel(this);
        var disabledClass = this.model.enabled ? "" : " wgt-disabled";

        return $r("li", {
                className: "kg-button" + disabledClass,
                style: (this.model.visible? {}: {display: 'none'})
            }, [ 
                $r("a", { href: "#", className: "item-link list-button", onClick: this.onClick }, this.model.name),

                this.props.showTooltip ? $r("div", {className: "collapsible-body"}) : null,
                this.props.showTooltip ? $r("div", { className: "button-tooltip"}, [
                    $r(WButtonTooltip, {model:this.model})
                ]): null
            ]
        );
    }
});


WButtonModern = React.createClass({
    displayName: "WButtonModern",
    mixins: [AbstractButtonClass],

    getInitialState: function() {
        return {
            collapsed: true
        };
    },

    render: function(){
        ButtonUtils.fetchModel(this);

        var tooltip = "";
        if (!this.state.collapsed) {
            tooltip = this.renderTooltip(this.model);
        }

        var titleClassName = "",
            isTogglable = this.model.togglableOnOff || this.model.togglable || this.model.togglableOnOffLink;

        if (isTogglable && this.model.on > 0){
            titleClassName = "bld-enabled";
        }

        //-------------------------------------------------
        //TODO: seriously consider moving it to controller
        //-------------------------------------------------
        var progress = 1.0;
        for (var i in this.model.prices) {
            var price = this.model.prices[i];

            var res = game.resPool.get(price.name),
                _progress = res.value / price.val;
            if (_progress < progress){
                progress = _progress;
            }
        }
        //-------------------------------------------------

        return $r(WCollapsibleSection, {
            title: this.model.name,
            _title: {
              className: titleClassName,
              onClick: this.onClick,
              onHold: this.onHold
            },
            ontoggle: this.toggle,
            disabled: !this.model.enabled,
            hidden: !this.model.visible,
            highlighted: this.model.resourceIsLimited,
            progress: progress,
            type: "button"
        }, tooltip);
    },

    renderTooltip: function(model){

        this.controller.fetchExtendedModel(this.model);

        var mainButtons = [];
        if (this.props.mainButtonClass) {

            mainButtons.push( $r(this.props.mainButtonClass, {
                title: this.props.mainButtonTitle,
                defaultOnClick: this.onClick,
                model: this.props.model,
                controller: this.props.controller
            }, this.props.mainButtonTitle));

        } else if (this.props.mainButtonTitle) {

            mainButtons.push( $r("a", {
                className: "button kg-button-build button-raised ",
                href: "#",
                onClick: this.onClick
            }, this.props.mainButtonTitle));
        }
        if (this.props.extraButtons){
            for (var i in this.props.extraButtons) {

                var extraBtnProps = this.props.extraButtons[i];
                var enabled = extraBtnProps.enabled ? " subbutton-enabled" : "";
                mainButtons.push(
                    $r("a", { 
                        className: "button kg-button-build button-raised" + enabled,
                        href: "#", 
                        'data-index': i,
                        onClick: this.onExtraBtnClick
                    }, extraBtnProps.title)
                );
            }
        }

        var buttons = [
            $r("p", { className: "buttons-row"},
                mainButtons
            )
        ];

        var subButtons = [];
        if (this.props.subButtons){
            for (var i in this.props.subButtons) {
                var subBtnProp = this.props.subButtons[i];
                var enabled = subBtnProp.enabled ? " subbutton-enabled" : " subbutton-disabled";
                subButtons.push(
                    $r("a", { 
                        className: "button kg-button-build button-raised" + enabled , 
                        href: "#", 
                        'data-index': i,
                        onClick: this.onSubLinkClick
                    }, subBtnProp.title)
                );
            }
        }

        if (subButtons.length) {
            buttons.push(
                $r("p", {className: "buttons-row"}, subButtons)
            );
        }


        return $r("div", {}, [
            $r("div", { className: "button-tooltip"}, [
                $r(WButtonTooltip, {
                    model: model
                })
            ]),
            $r("div", { className: "bld-tooltip-buttons"}, [
                buttons
            ])
        ]);
    },

    toggle: function(){
        this.setState({
            collapsed: !this.state.collapsed
        });
    },

    onExtraBtnClick: function(e) {
        var index = e.target.dataset.index;
        var extraBtnProp = this.props.extraButtons[index];

        e.stopPropagation();
        e.preventDefault();
        extraBtnProp.handler();
    },

    onSubLinkClick: function(e) {
        var index = e.target.dataset.index;
        var subBtnProp = this.props.subButtons[index];

        e.stopPropagation();
        e.preventDefault();
        subBtnProp.handler();
    }
});


WBuildingBtn = React.createClass({
    displayName: "WBuildingBtn",
    render: function(){
        ButtonUtils.fetchModel(this);

        var extraButtons = [];

        if (!this.model.enabled && game.bld.get("workshop").on > 0 && this.controller.isPrecraftAvailable && this.controller.isPrecraftAvailable(this.model)) {
            extraButtons.push(
                {
                    title: $I("btn.precraft"),
                    handler: dojo.hitch(this, this.precraft),
                    enabled: true
                }
            );
        }

        if (this.model.hasSellLink){
            extraButtons.push(
                {
                    title: $I("btn.sell"),
                    handler: dojo.hitch(this, this.sell),
                    enabled: true
                }
            );
        }

        var building = this.model.metadata;

        //--------------- style -------------
        // if((building.val > 9 || building.name.length > 10) && this.model.hasSellLink) {
        //     //Steamworks and accelerator specifically can be too large when sell button is on
        //     //(tested to support max 99 bld count)
        //     dojo.addClass(this.domNode, "small-text");
        // }

        var subButtons = [];
        if (this.model.togglableOnOffLink){
            subButtons.push(this.model.togglableOnOffLink);
        }

        if (this.model.toggleAutomationLink){
            subButtons.push(this.model.toggleAutomationLink);
        }

        if (building) {
            var isMaxed = this.model.on == building.val; //<<--- weird, check why model is incomplete
            var isZero = this.model.on == 0;

            if (this.model.togglable) {
                subButtons.push(
                    {
                        title: "+",
                        handler: dojo.partial(dojo.hitch(this.controller, this.controller.on), this.model),
                        enabled: isMaxed ? false : true
                    },
                    {
                        title: "+" + $I("btn.all.minor"),
                        handler: dojo.partial(dojo.hitch(this.controller, this.controller.onAll), this.model),
                        enabled: isMaxed ? false : true
                    },
                    {
                        title: "-",
                        handler: dojo.partial(dojo.hitch(this.controller, this.controller.off), this.model),
                        enabled: isZero ? false : true
                    },
                    {
                        title: "-" + $I("btn.all.minor"),
                        handler: dojo.partial(dojo.hitch(this.controller, this.controller.offAll), this.model),
                        enabled: isZero ? false : true
                    }
                );
            }
        }

        if (this.props.subButtons) {
            Array.prototype.push.apply(subButtons, this.props.subButtons);
        }

        return $r(WButtonModern, {
            ref: "buttonModern",
            controller: this.controller,
            model: this.model,
            mainButtonTitle: this.props.mainButtonTitle? this.props.mainButtonTitle : $I("btn.build"),
            mainButtonClass: WBuildingMainButton,
            extraButtons: extraButtons,
            subButtons: subButtons
        });
    },

    sell: function(event){
        this.refs.buttonModern.animate();
        this.controller.sell(event, this.model);
    },

    precraft: function(event){
        this.controller.precraft(this.model);
    },

    update: function() {
        // do nothing
    }
});

WBuildingMainButton= React.createClass({
    displayName: "WBuildingMainButton",

    render: function() {
        var prices = this.props.model.priceModels;
        var maxEta = this._getMaxEta(prices);

        var standardClasses = "button kg-button-build button-raised";

        if (!maxEta || this.props.model.enabled) {  //do not show notify for enabled buildings, it is buggy
            return $r("a", {
                className: standardClasses,
                href: "#",
                onClick: this.onClick
            }, this.props.title);
        } else {
            if (maxEta <= 3600) {
                return $r("a", {
                    className: standardClasses + " kg-reminder-button",
                    href: "#",
                    'data-eta': maxEta,
                    onClick: this.addReminder
                }, " ");
            } else {
                var denyReason = this.props.model.resourceIsLimited ? $I("res.notify.unavailable") :
                    $I("res.notify.unavailableTime", [game.getDisplayValueExt(maxEta, false, false, 0)]);

                return $r("a", {
                    className: standardClasses + " kg-reminder-button-disabled",
                    href: "#",
                    'data-reason': denyReason,
                    onClick: this.showExplanation
                }, " ");
            }
        }
    },

    _getMaxEta : function(prices){
        if (!prices || !prices.length) {
            return 0;
        }
        var currentEta = 0;
        for( var i = 0; i < prices.length; i++){
            var price = prices[i];
            if (price.hasLimitIssue) {
                return 99999;
            }
            var itemEta = price.eta;
            if (price.children && price.children.length) {
                var childEta = this._getMaxEta(price.children); 
                if (itemEta) {
                    // we need to use children eta if they will be available before the parent eta
                    itemEta = Math.min(childEta, itemEta);
                } else {
                    // since current doesn't increment it can return 0 and therefore use childEta
                    itemEta = childEta;
                }
            } 
            
            if (itemEta) {
                currentEta = Math.max(itemEta, currentEta);
            }
        }
        return currentEta;
    },

    onClick: function(e) {
        this.props.defaultOnClick(e);
    },

    addReminder: function(e) {
        var maxEta = e.target.dataset.eta;
        var reminderDate = new Date(new Date().getTime() + maxEta*2000);

        var notification = game.ui.notification;

        game.msg($I("res.notify.msg",[this.props.model.name]));
        notification.addReminder(reminderDate, $I("res.notify.ready", [this.props.model.name]), $I("res.notify.ready.title"), '1');
    },

    showExplanation: function(e) {
        var reason = e.target.dataset.reason;
        fw7App.alert(reason, 'Cannot add reminder');

    }

    // _addReminder: function() {
    //     // find out the date.
    //     var prices = this.model.priceModels;
    //     var maxEta = this._getMaxEta(prices);
    //     var reminderDate = new Date(new Date().getTime() + maxEta*1000);

    //     var notification = new classes.mobile.Notification();

    //     notification.addReminder(reminderDate, 'The '+this.model.name +' is ready', 'Enough resource to buy', '1');

    //     // var now = new Date().getTime();
    //     //   var _10SecondsFromNow = new Date(now + 10 * 1000);

    //     //   // cordova.plugins.notification.local.schedule({
    //     //   //   id: '1',
    //     //   //   title: 'Title here',
    //     //   //   text: 'Text here',
    //     //   //   at: _10SecondsFromNow
    //     //   // });

    //     // cordova.plugins.notification.local.schedule({
    //     //       id         : 1,
    //     //       title      : 'I will bother you every minute',
    //     //       text       : '.. until you cancel all notifications',
    //     //       //sound      : 'file://alarms/factory.wav',
    //     //       //sound: 'res://platform_default',
    //     //      // every      : 'minute',
    //     //       //badge      : 1,
    //     //       autoClear  : true,
    //     //       //ongoing    : true,
    //     //       at         : new Date(new Date().getTime() + 10*1000)
    //     //     });

    //     //   // cordova.plugins.notification.local.schedule({
    //     //   //     id: id,
    //     //   //     title: title,
    //     //   //     message: message,
    //     //   //     at: scheduleTime
    //     //   // });
    // },
});




WCollapsibleSection = React.createClass({
    displayName: "WCollapsibleSection",
    getInitialState: function() {
        return {
            collapsed:
                this.props.collapsed !== undefined ? this.props.collapsed : true,
            buttonGroup: false
        };
    },

    render: function(){
        return $r(WStatelessCollapsibleSection, {
            type: this.props.type,
            hidden: this.props.hidden, 
            collapsed: this.state.collapsed,
            titleHTML: this.props.titleHTML,
            _title: this.props._title,
            disabled: this.props.disabled,
            title: this.props.title,
            ontoggle: this.toggle,
            highlighted: this.props.highlighted,
            progress: this.props.progress,
        }, this.props.children);
    },

    toggle: function(){
        this.setState({
            collapsed: !this.state.collapsed
        }, function(){
            //holy fuck, you can actually do this
            if (!this.state.collapsed && this.props.type == "button"){
                /*var elem = React.findDOMNode(this);
                elem.scrollIntoView();

                //just don't ask
                $(".view-main .page-content")[0].scrollTop -= 44;*/
            }
        });

        if (this.props.ontoggle) {
            this.props.ontoggle(!this.state.collapsed); 
        }
    }
});


WStatelessCollapsibleSection = React.createClass({
    displayName: "WStatelessCollapsibleSection",

    shouldComponentUpdate: function(nextProps, nextState) {
        if (this.props.hidden != nextProps.hidden) {
            return true;
        }
        if (this.props.collapsed && nextProps.collapsed && 
            //this.props.collapsed && nextProps.collapsed &&
            this.props.titleHTML === nextProps.titleHTML &&

            ((!this.props._title && !nextProps._title) || ( 
                this.props._title && 
                nextProps._title && 
                this.props._title.className === nextProps._title.className && 
                this.props._title.onClick === nextProps._title.onClick &&
                this.props.progress === nextProps.progress
                )
            ) &&
            this.props.disabled === nextProps.disabled
        ) {

            if (this.props.title === nextProps.title &&
                this.props.children === nextProps.children
            ){
                return false;
            }
        }
        
        return true;
    },


    render: function(){

        var sectionClass = "";
        var collapsedClass = "";

        if (this.props.disabled){
            sectionClass += " wgt-disabled";
        }
        if (this.props.collapsed){
            collapsedClass += " wgt-collapsed";
        }
        if (this.props.type){
            sectionClass += " wgt-type-" + this.props.type;
        }
        if (this.props.highlighted && game.opts.highlightUnavailable){
            sectionClass += " wgt-highlighted";
        }

        //TODO: use this.props.title.HTML instead of this.props.titleHTML (and also _title.name
        if (this.props._title && this.props._title.className){
            sectionClass += " " + this.props._title.className;
        }


        //TODO: collapse the if statement into a single rendering line;
        var div;
        if (this.props.titleHTML) {
            div = $r("div", {className: "kg-collapsible" + sectionClass, style: (!this.props.hidden? {}: {display: 'none'}) }, [
                $r("div", {
                    className: "collapsible-title",
                    onClick: this.toggle,
                    dangerouslySetInnerHTML: {__html: this.props.titleHTML}   /* We need it for planet glyphs unfortunately */
                }),
                $r("div", {className: "collapsible-body" + collapsedClass}, this.props.children)
            ]);
        } else {
            div = $r("div", {className: "kg-collapsible" + sectionClass, style: (!this.props.hidden? {}: {display: 'none'})}, [
                $r("div", {
                    className: "collapsible-title",
                    onClick: this.toggle
                },
                    /* ------------------------------
                    A small part of the collapsible title left from the '>' icon that contains title text
                    ---------- ---------------------*/
                    $r("div", {
                            className: "title-content",
                            onClick: this.props._title ? this.titleClick : null,
                            ref: "titleContent"
                        },
                        [
                            this.props.title
                        ]
                    )
                ),
                $r("div", {className: "collapsible-body" + collapsedClass}, this.props.children),
                this.props.progress < 1.0 ? $r("progress", {value: this.props.progress}) : null
            ]);
        }
        return div;
    },

    componentDidMount: function(){
        var ref = this.refs["titleContent"];
        if (ref) {
            ref.getDOMNode().addEventListener("taphold", this.titleHold);
        }
    },

    componentWillUnmount: function() {
        var ref = this.refs["titleContent"];
        if (ref) {
            ref.getDOMNode().removeEventListener("taphold", this.titleHold);
        }
    },

    titleClick: function(event) {
        if (this.props.disabled){
            //no gain for disabled buttons to do inline handler
            this.toggle();
        }

        event.stopPropagation();
        this.props._title.onClick(event);
    },

    titleHold: function(event){
        console.log("registered taphold event");
        if (this.props.disabled){
            //no gain for disabled buttons to do inline handler
            this.toggle();
        }

        event.stopPropagation();
        this.props._title.onHold(event);
    },

    toggle: function(){
        if (this.props.ontoggle) {
            this.props.ontoggle(!this.props.collapsed);
        }
    }
});


WSmartSelect = React.createClass({
    displayName: "WSmartSelect",
    render: function() {

        var items = this.props.items;
        var selectedValue = this.props.selectedValue;
        var selectedLabel;
        var options = [];
        for (var i=0 ; i < items.length; i++) {
            var item = items[i];
            var selected =
                (selectedValue && item.value === "true") ||
                (!selectedValue && item.value === "false");

            if (selected) {
                selectedLabel = item.label;
            }
            options.push($r("option", {value: item.value}, item.label));
        }
        if (selectedLabel === null || selectedLabel === undefined) {
            // selected value wasn't found. Which may be fine, let's us just show it instead of label.
            selectedLabel = selectedValue;
        }

        var result = $r("a", {href:'#', className : "item-link smart-select", "data-open-in":"page", "data-back-on-select": "true"}, [
            $r("select", {onChange: this.props.onChange, value: selectedValue}, options),
            $r("div",{className : "item-content"}, [
                $r("div",{className : "item-inner"}, [
                    $r("div",{className : "item-title"}, this.props.title),
                    $r("div",{className : "item-after"}, selectedLabel)
                    
                ])
            ])
        ]);
        return result;
    }
});


WButtonTooltip = React.createClass({
    displayName: "WButtonTooltip",
    render: function(){
        var model = this.props.model;
        var children = [];
        if (model.tooltipName) {
            children.push($r("div", {
                className: "tooltip-divider",
                style: {
                    textAlign: "center",
                    width: "100%",
                    borderBottom: "1px solid gray",
                    paddingBottom: "4px"
                }
            }, model.name));
        }

        var prices = model.priceModels;
        var effects = model.effectModels;
        var flavor = model.flavor;

        var descriptionClassNames = "desc";
        var hasExtraContent = (prices && prices != "" || effects || flavor && flavor != "");

        if (hasExtraContent) {
            descriptionClassNames += " withExtraContent";
        } else {
             descriptionClassNames += " withNoExtraContent";
        }

        if (prices){
            descriptionClassNames += " withPrices";
        }

        // description
        var descDiv = $r("div", {
            className: descriptionClassNames,
            dangerouslySetInnerHTML: { __html: model.description}
        });

        children.push(descDiv);

        // prices
        if (prices){
            this.renderPrices(children, model);    //simple prices
        }

        if (effects){
            this.renderEffects(children, effects);
        }

        if (flavor && flavor != "") {
            var flavorDiv = $r("div", {
                className: "flavor"
            }, flavor);
            children.push(flavorDiv);
        }
        
        
        return $r("div", { className: "tooltip-inner" }, children);
    },

    renderPrices : function(children, model){
        var prices = model.priceModels;
        if (!prices.length){
            return;
        }
        for( var i = 0; i < prices.length; i++){
            var price = prices[i];
            this._renderPriceLine(children, price, model.simplePrices);
        }
    },

    _renderPriceLine : function(children, price, simpleUI){

        var priceItemNodes = [];

        var content = price.title;
        for (var k = 0; price.indent && k < price.indent; ++k) {
            content = "\u00a0\u00a0\u00a0" + content;
        }
        var nameSpan = $r("span", {  className: "priceTitle" + (price.indent? " raw": "") }, content );
        priceItemNodes.push(nameSpan);

        var priceSpan = $r("span", {
            className: "priceValue" + (price.hasResources ? "" : " noRes")
        }, price.displayValue );
        priceItemNodes.push(priceSpan);

        var priceItemNode = $r("div", {
                className: "price-block"
            }, priceItemNodes);
        children.push(priceItemNode);

        if (price.children && price.children.length) {
            for (var i = 0; i < price.children.length; i++ ) {
                this._renderPriceLine(children, price.children[i], simpleUI);
            }
        }        
    },

    renderEffects : function(children, effectsList, hideTitle){
        if (!effectsList || !effectsList.length) {
            return;
        }

        if (!hideTitle){
            children.push($r("div", {
                className: "tooltip-divider",
                }, $I("res.effects") + ":" ));
        }

        //-----------------------------------------

        for (var i =0; i < effectsList.length; i++){
            var effectModel = effectsList[i];

            children.push(
                $r("div", { 
                    className: "effectName"
                }, 
                effectModel.displayEffectName + ": " + effectModel.displayEffectValue )
            );
            
        }

    }
});


GameUpdateTrackerMixin = {

    subscribeHander: null,
    
    componentDidMount: function() {
        var self = this;
        this.subscribeHander = dojo.subscribe("game/update", function(game) {
            setTimeout(dojo.hitch(self, dojo.partial(self.onGameUpdate, game)), 0);
        });
    },

    componentWillUnmount: function() {
        if (this.subscribeHander) {
            dojo.unsubscribe(this.subscribeHander);
        } 
    }
};


TwoInRowHelper = {
    
    layout: function(buttons, firstButtonIsToggle) {
        var elems = [], i , row;
        if (game.opts && game.opts.useLegacyTwoInRowLayout) {
            var cells = [];
            for (i in buttons){
                cells.push($r("div", {className: "col-50"}, buttons[i]));
                //commit da row (lol)
                if (i % 2 !== 0 || (buttons.length && i == (buttons.length-1))) {
                    row = $r("div", {className: "row"}, cells);
                    elems.push(row);
                    cells = [];
                }
            }
        } else {
            // right and left cols:
            var leftTechButtons = [], rightTechButtons=[];
            if (firstButtonIsToggle) {
                elems.push(buttons[0]);
            }
            var even = true;
            for (i=firstButtonIsToggle? 1: 0; i < buttons.length; i++) {
                if (even) {
                    leftTechButtons.push(buttons[i]);
                } else {
                    rightTechButtons.push(buttons[i]);
                }
                even = !even;
            }

            row = $r("div", {className: "row"}, [
                $r("div", {className: "col-50"}, leftTechButtons),
                $r("div", {className: "col-50"}, rightTechButtons)
            ]);
            elems.push(row);
        }
        return elems;
    }
};
